﻿//※【未完】＞タグのヘルプを入れる
/**

///	レイヤー名連番化スクリプト

	制作：彩藤神楽	(http://www.re-sonance.com/)


	Copyright (C) 2007-2008 Saitoh Kagura, All Rights Reserved.

 */

const SCRIPT_TITLE	= "レイヤー名連番化";
const VERSION		= "0.1.00";


///-------------------------------------------------------------
///	外部スクリプトファイル読み込み
//--------------------------------------------------------------
#include "./lib/Resonance.jsxinc"
#include "./lib/ScriptUtil.jsxinc"
#include "./lib/LayerUtil.jsxinc"
#include "./lib/FileUtil.jsxinc"
#include "./lib/StringUtil.jsxinc"
#include "./lib/ConfigDialog.jsxinc"


///-------------------------------------------------------------
///	グローバル
//--------------------------------------------------------------

//--> 基礎準備
#target photoshop
app.bringToFront();
const NEW_LINE	= Resonance.NEW_LINE;
const NEW_LINE2	= NEW_LINE + NEW_LINE;
_resonance		= new Resonance(SCRIPT_TITLE, VERSION);

///> 空値用定数
const EMPTY_CHAR		= "*";

///> タグ定数
const BASE_TAG			= "<name>";
const NUM_TAG			= "<num>";
const WORD_TAG			= "<str>";
const BASE_TAG_REG		= /<name>/g;
const NUM_TAG_REG		= /<num>/g;
const WORD_TAG_REG		= /<str>/g;

///> ダイアログ用定数


const CONFIRM_PREFIX	= "【 ";
const CONFIRM_SUFFIX	= " 】内のレイヤーを連番化します。" + NEW_LINE2 + "よろしいですか？";
const MESSAGE_COMPLETE	= "レイヤー名の連番化が完了しました。";

///> アルファベット定数
const ALPHABETS_S	= ["a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"];
const ALPHABETS_B	= ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"];

//> グローバルに扱う設定系オブジェクト
var _config;

///> 設定データ
var _configData	= {};
_configData.infoData	= {
	 _toSimulate: "↓"
	,CountType	: ["数値のみ(&N)", "英字（小）(&L)", "英字（大）(&B)", "ユーザー定義(&U)"]
	,_Start		: "開始値:"
	,Figure		: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16]
	,_Figure	: "最小桁数:"
	,Notation	: ["10進数", "2進数", "8進数", "16進数", "16進数（大）"]
	,Reversed	: "逆順(&R)"
	,Cycled		: "循環(&C)"
	,_Format	: "書式:"
	,_UserList	: "定義（カンマ区切り）:"
	,_userListBrowser	: "ユーザー定義連番ファイルを選択して下さい。"
	,_userListFileType	:  "テキスト・CSVファイル:*.txt;*.csv,すべてのファイル:*"
};
//> ヘルプチップ
_configData.helpData	= {
	 _metaTitle		: "ユーザー定義連番名"
};
_configData.listData	= {
	 CountType	: ["n", "a", "a2", "u"]
	,_CountTypeOfNumber	: 0
	,_CountTypeOfUser	: _configData.infoData.CountType.length - 1
	,Notation			: [10, 2, 8, 16, 16]
	,_BigNotation		: _configData.infoData.Notation.length - 1
};
_configData.defaultData	= {
	 ScriptTitle	: SCRIPT_TITLE
	,ScriptVersion	: VERSION
	,CountType	: 0
	,Start		: 1
	,Figure		: 0
	,Notation	: 0
	,BigNotation: false
	,Reversed	: false
	,Cycled		: true
	,Format		: BASE_TAG + "_" + WORD_TAG + NUM_TAG
	,UserList	: []
};
_configData.widthData	= {
	 "_main,_progressInfo,_progress"	: 340
	,"_baseNames,_simulate"	: 170
	,Format	: 120
	,Figure	: 50
	,Start	: 60
	,"Notation,UserList"	: 120
};
_configData.heightData	= {
	 "_baseNames,_simulate"	: 140
};

//--> 本体実行
main();


///-------------------------------------------------------------
///	メインフロー関数
//--------------------------------------------------------------

///{} 本体
function main() {

	//--? 起動時チェック
	try{
		ScriptUtil.inspectDocumentExists();
		ScriptUtil.inspectPhotoshopVersion();
		ScriptUtil.inspectDocumentFormat();
	}catch(e){
		_resonance.showError(e);
		return;
	}

	try{

		mainFlow();

	}catch(e){
		_resonance.showError(e);
	}

};


///{} メインフロー
function mainFlow() {

	//--> 設定読み込み
	loadConfig();

	//--? 設定ダイアログを表示してキャンセルされなければ一斉出力処理
	if(_config.show()){

		renameLayers();

		_config.alertAs(MESSAGE_COMPLETE, _resonance.windowTitle);

	}

};


///{} 設定読み込みその編集用ダイアログを配置
function loadConfig() {

	//--> XMLデータとダイアログ設定を関連付けるクラスを生成
	_config	= new ConfigDialog(_configData);
	ScriptUtil.tries(_resonance.windowTitle, _config.connectXMLON, _config, [
		 _resonance.configFilePath
		,SCRIPT_TITLE
	]);

	_config.title	= _resonance.windowTitle;

  ///{} ダイアログのレイアウトと設定データの対応を準備する
  _config.prepare	= function(){

	//--> ドキュメント名のオプションを取得して見つかればパターン定義に適用
	var metaData_str	= _resonance.getConfigMetaData();
	if(metaData_str){
		_config.data.UserList	= metaData_str.split(",");
		_config.data.CountType	= _config.listData._CountTypeOfUser;
	}

	//> 対象レイヤー群の親要素
	var activeLayer	= activeDocument.activeLayer;
	var showParent	= (activeLayer.typename == "LayerSet" || activeLayer.typename == "Document") ?
		activeLayer
		:
		activeLayer.parent;

	this.confirmMessage	= CONFIRM_PREFIX + showParent.name + CONFIRM_SUFFIX;

	//--> 対象レイヤー群の名前を取得
	function getLayerNames(){
		_config.global.layers	= [];
		var layers	= showParent.layers;
		var layer;
		var a	= [];
		var len	= layers.length;
		for(var i = 0; i < len; i++){
			layer	= layers[i];
			if(layer.typename != "LayerSet"){
				_config.global.layers.push(layer);
				a.push(layer.name);
			}
		}
		return a;
	};
	var layerNames	= getLayerNames();

	const BROAD_SPACE		= ConfigDialog.BROAD_SPACE;

	const column_opt	= this.setOptions({orientation:"column"});
	const custom_opt	= this.setOptions({orientation:"column", alignChildren:"left", spacing:6});

	//--> メインウィンドウ生成
	this.create({orientation:"column"});

	//--> 編集パネル
	this.addPanel("_main", {orientation:"row", spacing:BROAD_SPACE} ,StringUtil.getFullName(showParent, "/", "LayerSet"));

	//--> 対象レイヤー群表示グループ
	this.addGroup("_main/_target", column_opt);
		//--> 対象レイヤー群表示リストボックス
		this.addListBox("_baseNames", undefined, undefined, layerNames);
		this.addText("_toSimulate", {alignment:"center"});
		var simulate_lbx	= this.addListBox("_simulate");
	//--> 設定変更グループ
	this.addGroup("_main/_custom", custom_opt);
		//--> 形式
		this.addGroup("_main/_custom/_format", custom_opt);
			this.addText("_Format");
			this.addEditText("Format");
			this.ascend();
		//--> 計上タイプ
		this.addGroup("_main/_custom/CountType", custom_opt);
			var num_rbt		= this.addRadioButtonItem();
			this.addRadioButtonItem();
			this.addRadioButtonItem();
			var user_rbt	= this.addRadioButtonItem();
			this.ascend();
		//--> 逆順
		this.addButton("Reversed", undefined, "onClickReverse");
		//--> 循環
		this.addCheckBox("Cycled");

		//--> 桁数
		this.addGroup("_main/_custom/_figure");
			this.addText("_Figure");
			this.addDropDownList("Figure");
			this.ascend();
		//--> 開始値
		this.addGroup("_main/_custom/_start");
			this.addText("_Start");
			this.addEditText("Start");
			this.ascend();
		//--> n進数
		this.addDropDownList("Notation");
		//--> ユーザー定義
		this.addText("_UserList");
		var user_etx	= this.addEditText("UserList");
		this.addButton("_userListButton", {alignment:"right"}, "onClickUserBrowser", ConfigDialog.button.BROWSER);

	this.addGroup("_other");
		this.addConfirmCheckBox();
		this.addMetaDataButton();

	//--> 標準ボタン
	var button_grp	= this.addMainButton("_button", {alignment:"right"}, true, true);

	//{} シミュレートリスト更新
	function renewRenameList(){
		simulate_lbx.removeAll();
		_config.global.renames	= [];
		var len	= layerNames.length;
		var max	= len - 1;
		for(var i = 0; i < len; i++){
			_config.global.renames[i]	= getCount(_config.data.Reversed ? i : (max - i)
				,_config.data.Format.replace(BASE_TAG_REG, layerNames[i])
			)
			simulate_lbx.add("item", _config.global.renames[i]);
		}
	};
	renewRenameList();

	/// イベントハンドラ

	var eventListener	= {};

	//e{} 逆順ボタンイベント
	eventListener.onClickReverse	= function(conf, item){
		conf.data.Reversed	= !conf.data.Reversed;
		renewRenameList();
	};

	//{} カウントタイプ強制変更
	function changeUserList(){
		if(_config.showed){
			user_rbt.value	= true;
			_config.data.CountType	= _config.listData._CountTypeOfUser;
		}
	};

	//e{} ユーザー定義連番ファイル選択イベント
	eventListener.onClickUserBrowser	= function(){
		var result_file = File.openDialog(_config.infoData._userListBrowser, _config.infoData._userListFileType);
		if(result_file){
			result_file.open("r");
			var s	= result_file.read();
			result_file.close();
			user_etx.text	= s	= s.replace(/[\r\n]/gm, ",").replace(/,+/g, ",");
			_config.data.UserList	= s.split(",");
			changeUserList();
			renewRenameList();
		}
	};

	///e{} 汎用設定データ変更イベント
	eventListener.onChangeValue	= function(conf, item){
		switch(item.name){
			case "Start":
				item.text	= _config.data.Start	= isNaN(item.text) ? 1 : parseInt(item.text);
				break;
			case "Figure":
				break;
			case "Notation":
				conf.data.BigNotation	= (conf.data.Notation == conf.listData._BigNotation);
				break;
			case "UserList":
				conf.data.UserList	= item.text.split(",");
				//--? ユーザー定義設定以外で定義文字が空にされた場合は更新しない
				if(!(!item.text && conf.data.CountType != conf.listData._CountTypeOfUser)){
					changeUserList();
				}
				break;
			default:
				break;
		}
		renewRenameList();
	};

	///e{} メタデータ取得ボタンイベント
	eventListener.onClickMetaData	= function(conf, item){
		_resonance.setConfigMetaData(conf.helpData._metaTitle, user_etx.text);
	};

	//e{} エラー表示イベント
	eventListener.onError	= function(conf, item, e){
		alert("<onError>" + e + "\n" + dump(item), Resonance.title.ERROR, true);	//※【未完】
	};

	//--> イベントリスナーを登録
	this.setListener(eventListener);

  };

};


///{$} 設定に応じた連番値を取得
function getCount(n, s){

	var data	= _config.data;

	var CountType	= _config.getListValue("CountType");

	//--? 数値の場合の処理
	var getCountInNumber	= function(n){
		var s	= (n + data.Start).toString(_config.getListValue("Notation"));
		s	= StringUtil.supply0To(s, _config.getListValue("Figure"));
		if(data.BigNotation){
			return s.toUpperCase();
		}else{
			return s;
		}
	};

	//--? リストから適用
	var a;
	switch(CountType){
		case "n":
			return s.replace(WORD_TAG_REG, "").replace(NUM_TAG_REG, getCountInNumber(n));
		case "a":
			a	= ALPHABETS_S;
			break;
		case "a2":
			a	= ALPHABETS_B;
			break;
		case "u":
			a	= data.UserList;
			break;
		default:
			return s.replace(WORD_TAG_REG, "").replace(NUM_TAG_REG, EMPTY_CHAR);
	}

	var word;
	var len	= a.length;
	if(data.Cycled){
		//(!) 循環
		var divide	= Math.floor(n / len);
		var figure0	= _config.getListValue("Figure");
		word	= len ? a[n % len] : EMPTY_CHAR;
		n		= (len && figure0) ? getCountInNumber(divide) : "";
	}else{
		//(!) 非循環
		word	= (len && n < len) ? a[n] : EMPTY_CHAR;
		n		= getCountInNumber(n);
	}

	return s.replace(WORD_TAG_REG, word).replace(NUM_TAG_REG, n);

};


///{} レイヤー名変更
function renameLayers() {

	var global		= _config.global;
	var layers		= global.layers;
	var renames		= global.renames;

	//※レイヤー選択の選択状況によって一番上のレイヤーだけリネームされない問題の回避策
	if(layers.length > 1 && activeDocument.activeLayer == layers[0]){
		activeDocument.activeLayer	= layers[1];
	}else{
		activeDocument.activeLayer	= layers[0];
	}

	var visible;
	var rate	= 0;
	var len		= layers.length;
	for(var i = 0; i < len; i++){
		visible	= layers[i].visible;
		layers[i].name	= renames[i] ? renames[i] : " ";
		layers[i].visible	= visible;
	}

	activeDocument.activeLayer	= layers[0];

};


