﻿//※【未完】＞レイヤーセットのみの設定にしてもアートレイヤーを取得してしまう事がある？
//※【未完】＞置換を連続で行うとアンドゥ結果が予測しづらくなる。
/**

///	レイヤー名を特定の条件で置換するスクリプト

	制作：彩藤神楽	(http://www.re-sonance.com/)


	Copyright (C) 2007-2008 Saitoh Kagura, All Rights Reserved.

 */

const SCRIPT_TITLE	= "レイヤー名置換";
const VERSION		= "0.1.00";


///-------------------------------------------------------------
///	外部スクリプトファイル読み込み
//--------------------------------------------------------------
#include "./lib/Resonance.jsxinc"
#include "./lib/ScriptUtil.jsxinc"
#include "./lib/StringUtil.jsxinc"
#include "./lib/LayerUtil.jsxinc"
#include "./lib/ConfigDialog.jsxinc"


///-------------------------------------------------------------
///	グローバル
//--------------------------------------------------------------

//--> 基礎準備
#target photoshop
app.bringToFront();
const NEW_LINE	= Resonance.NEW_LINE;
const NEW_LINE2	= NEW_LINE + NEW_LINE;
const NEW_LINE_ON_FS	= Resonance.NEW_LINE_ON_FS;
_resonance		= new Resonance(SCRIPT_TITLE, VERSION);

///> 正規表現マッチ文字列置き換え用記号
const MATCH_SIGNS		= [/\$1/g, /\$2/g, /\$3/g, /\$4/g, /\$5/g, /\$6/g, /\$7/g, /\$8/g, /\$9/g, /\$\&/g, /\$`/g, /\$"/g, , /\$\+/g];

///> 確認ダイアログ
const TITLE_RESULT		= "レイヤー名を置き換えました。";
const TITLE_UNDO_RESULT	= "レイヤー名を元に戻しました。";
const CONFIRM_PREFIX	= "レイヤー名を以下のように置き換えます。" + NEW_LINE2;
const CONFIRM_BETWEEN	= NEW_LINE + "↓" + NEW_LINE;
const CONFIRM_SUFFIX	= NEW_LINE2 + "よろしいですか？";

///> エラーメッセージ
const ERROR_NOT_NAME	= "置換対象文字列を指定して下さい。";
const ERROR_NOT_FOUND	= "置き換え条件にマッチするレイヤーはありませんでした。";
const ERROR_NOT_RESULT	= "置き換えは行われませんでした。";

//> グローバルに扱う設定系オブジェクト
var _config;

///> 設定データ
var _configData	= {};
_configData.infoData	= {
	 _replacePrefix	: "置換範囲【 "
	,_replaceSuffix	: " 】"
	,AsAllLayers	: "全体を置換対象にする(&T)"
	,AsRegular		: "正規表現を使用(&R)"
	,AsSubLayerSets	: "サブレイヤーセット内にも適用(&L)"
	,RigidlyInspected	: "大文字と小文字を区別する(&I)"
	,VisibleOnly	: "表示レイヤーのみ対象にする(&V)"
	,Target			: ["レイヤー及びレイヤーセット", "レイヤーのみ", "レイヤーセットのみ"]
	,_Target		: "置換対象:"
	,_LayerFilter	: "置換対象名フィルタ:"
	,_ReplaceName	: "対象文字:"
	,_ReplaceString	: "置換内容:"
	,_replaceButton	: "置換"
	,_undoButton	: "修復"
};
_configData.helpData	= {
	 AsRegular		: "JavaScriptの正規表現でレイヤー名を置換します。"
};
_configData.defaultData	= {
	 ScriptTitle	: SCRIPT_TITLE
	,ScriptVersion	: VERSION
	,ReplaceName	: ""
	,ReplaceString	: ""
	,NameHistory	: []
	,StringHistory	: []
	,RigidlyInspected	: false
	,AsAllLayers	: false
	,AsRegular		: false
	,AsSubLayerSets	: false
	,VisibleOnly	: false
	,LayerFilter	: ""
	,Target			: 0
};
_configData.listData	= {
	 Target			: ["", "ArtLayer", "LayerSet"]
};
_configData.widthData	= {
	 "ReplaceName,ReplaceString"		: 160
	,"NameHistory,StringHistory"		: 100
	,"_replace,_progressInfo,_progress,_logScreen"	: 340
	,LayerFilter	: 140
	,_hr	: 310
};
_configData.heightData	= {
	 _logScreen	: 60
};


//--> 本体実行
main();


///-------------------------------------------------------------
///	メインフロー関数
//--------------------------------------------------------------

///{} 本体
function main() {

	//--? 起動時チェック
	try{
		ScriptUtil.inspectDocumentExists();
		ScriptUtil.inspectPhotoshopVersion();
		ScriptUtil.inspectDocumentFormat();
	}catch(e){
		_resonance.showError(e);
		return;
	}

	try{

		mainFlow();

	}catch(e){
		_resonance.showError(e);
	}

	deleteTemporaryLayer();

};


///{} メインフロー
function mainFlow() {

	//--> 設定読み込み
	loadConfig();

	//--> 設定ダイアログ表示
	_config.show()

};


///{} 設定読み込みその編集用ダイアログを配置
function loadConfig() {

	//--> XMLデータとダイアログ設定を関連付けるクラスを生成
	_config	= new ConfigDialog(_configData);
	ScriptUtil.tries(_resonance.windowTitle, _config.connectXMLON, _config, [
		 _resonance.configFilePath
		,SCRIPT_TITLE
		,VERSION
	]);

	_config.title	= _resonance.windowTitle;

	initHistory();

  _config.prepare	= function(){

	this.global.targetParent	= LayerUtil.getTargetParentLayer(activeDocument.activeLayer);

	/// レイアウト

	const column_opt	= this.setOptions({orientation:"column"});
	const row_opt		= this.setOptions({orientation:"row"});
	const narrowRow_opt	= this.setOptions({orientation:"row", spacing:ConfigDialog.NARROW_SPACE});

	//--> メインウィンドウ生成
	this.create();

	//--> メイングループ
	var allTarget		= this.infoData._replacePrefix + activeDocument.name + this.infoData._replaceSuffix;
	var parentTarget	= this.infoData._replacePrefix + StringUtil.getFullName(this.global.targetParent, "/", "LayerSet") + this.infoData._replaceSuffix
	this.addGroup("_main", column_opt);
		this.addCheckBox("AsAllLayers", {alignment:"left"}, "onClickAllLayers");
		var replace_pnl	= this.addPanel("_main/_replace", column_opt, this.data.AsAllLayers ? allTarget : parentTarget);
			this.addGroup("_main/_replace/_edit", narrowRow_opt);
				this.addText("_ReplaceName");
				var name_etx	= this.addEditText("ReplaceName");
				var name_ddl	= this.addDropDownListMenu("NameHistory", undefined, "onChangeNameHistory");
			this.addGroup("_main/_replace/_edit2", narrowRow_opt);
				this.addText("_ReplaceString");
				var string_etx	= this.addEditText("ReplaceString");
				var string_ddl	= this.addDropDownListMenu("StringHistory", undefined, "onChangeStringHistory");
				this.ascend();
			this.addHorizon("_hr");
			this.addGroup("_main/_replace/_target", row_opt);
				this.addText("_Target");
				this.addDropDownList("Target");
			this.addGroup("_main/_replace/_filter", row_opt);
				this.addText("_LayerFilter");
				this.addEditText("LayerFilter");
			this.addGroup("_main/_replace/_custom", {orientation:"column", alignChildren:"left"});
				this.addCheckBox("RigidlyInspected");
				this.addCheckBox("AsRegular");
				this.addCheckBox("AsSubLayerSets");
				this.addCheckBox("VisibleOnly");
				this.ascend();

	this.changeParentGroup("_main/");
	this.addConfirmCheckBox();

	//--> 進捗グループ
	this.addGroup("_main/_progress", column_opt);
		var replace_stx	= this.addText("_progressInfo");
		var replace_prg	= this.addProgressBar("_progress");
		replace_prg.info_item	= replace_stx;

	//--> 基本ボタン
	this.addGroup("_main/_button", row_opt);
		this.addButton("_replaceButton", undefined, "onClickReplace", undefined, undefined, "defaultElement");
		var undo_btn	= this.addButton("_undoButton", undefined, "onClickUndo");
		undo_btn.enabled	= false;
		this.addCancelButton();
		this.addApplyButton();
//		this.addResetButton();	※レイアウトの都合で暫定削除

		this.ascend();
	var replaceLog_etx	= this.addEditText("_logScreen", undefined, undefined, "", {multiline:true, readonly:true});


	/// イベントハンドラ

	var eventListener	= {};

	//e{} 置換対象全体切り替えボタンイベント
	eventListener.onClickAllLayers	= function(conf, item){
		replace_pnl.text	= item.value ? allTarget : parentTarget;
	};

	//e{} 置換名履歴変更イベント
	eventListener.onChangeNameHistory	= function(conf, item){
		if(item.selection.text){
			conf.data.ReplaceName	= name_etx.text	= item.selection.text;
		}
	};

	//e{} 置換文字列履歴変更イベント
	eventListener.onChangeStringHistory	= function(conf, item){
		if(item.selection.text){
			conf.data.ReplaceString	= string_etx.text	= item.selection.text;
		}
	};

	///e{} 置換ボタンイベント
	eventListener.onClickReplace	= function(conf, item){
		if(!name_etx.text){
			conf.alertAs(ERROR_NOT_NAME);
			return;
		}
		var data	= conf.data;
		try{
			if(conf.confirmAs(CONFIRM_PREFIX + '"' + data.ReplaceName + '"' + CONFIRM_BETWEEN + '"' + data.ReplaceString + '"' + CONFIRM_SUFFIX)){
				name_ddl.addHistory(name_etx.text);
				string_ddl.addHistory(string_etx.text);
				conf.save();
				replace_prg.onStartProgress();
				replaceLog_etx.text	= "";
				replaceLayerNames(replace_prg, replaceLog_etx);
				replace_prg.onCompleteProgress();
				undo_btn.enabled	= (_config.global.history.length > 0);
//				conf.close(true);
			}
		}catch(e){
			if(!ConfigDialog.isCancelProgressError(e)){
				conf.alertAs(e, Resonance.title.ERROR, true);
				replace_prg.onProgressError();
			}
		}
	};

	///e{} アンドゥボタンイベント
	eventListener.onClickUndo	= function(conf, item){
		if(conf.confirmAs("レイヤー名を元に戻しますか？")){
			replace_prg.onStartProgress();
			replaceLog_etx.text	= "";
			undoLayerNames(replace_prg, replaceLog_etx);
			replace_prg.onCompleteProgress();
			undo_btn.enabled	= (_config.global.history.length > 0);
		}
	};

	//--> イベントリスナーを登録
	this.setListener(eventListener);

	//--? 直実行専用処理
	if(this.data.directly){
		this.dispatchEvent("onClickReplace");
	}

  };

};


///{} テンポラリレイヤー生成	※レイヤー選択状況によっては名前変更の対象にならない事があるのでテンポラリレイヤーを作ってそこを選択しておく。
function createTemporaryLayer() {

	if(!_config.global.temp_layer){
		var temp_layer	= activeDocument.artLayers.add();
		temp_layer.name	= _resonance.temporaryLayerName;
		_config.global.temp_layer	= temp_layer;
		activeDocument.activeLayer	= temp_layer;
	}

	return _config.global.temp_layer;

};


///{} テンポラリレイヤー削除
function deleteTemporaryLayer() {

	if(_config.global.temp_layer){
		activeDocument.activeLayer	= _config.global.temp_layer;
		_config.global.temp_layer.remove();
	}

};



///{} レイヤー名変更履歴初期化
function initHistory() {

	_config.global.history	= [];

};


///{} レイヤー名変更履歴追加
function addHistory(layer, beforeName, afterName) {

	_config.global.history.push({layer:layer, beforeName:beforeName, afterName:afterName});

};


///{} レイヤー名置換
function replaceLayerNames(eventHandler, replaceLog_etx) {

	var data	= _config.data;

	var word	= data.AsRegular ? data.ReplaceName : StringUtil.escapeRegExp(data.ReplaceName);
	if(!word){
		throw new Error(ERROR_NOT_NAME);
	}

	var temp_layer	= createTemporaryLayer();

	var replaceWord	= data.ReplaceString;
	var replace_reg	= new RegExp(word, data.RigidlyInspected ? "g" : "ig");

	var filter_reg	= new RegExp(data.LayerFilter ? data.LayerFilter : ".*", data.RigidlyInspected ? "g" : "ig");

	var VisibleOnly	= data.VisibleOnly;

	var targetLayersName	= (_config.getListValue("Target") == "LayerSet") ? "layerSets" : "layers";
	var found		= false;
	var result		= false;
	var beforeVisible	= false;
	LayerUtil.each(
		 data.AsAllLayers ? activeDocument[targetLayersName] : _config.global.targetParent[targetLayersName]
		,function(layer){
			if(!_config.isProgressing){
				throw new ConfigDialog.CancelProgressError();
			}
			if(layer == temp_layer){
				return;
			}
			var Target	= _config.getListValue("Target");
			switch(layer.typename){
				case "LayerSet":
					if(Target == "ArtLayer"){
						return;
					}
					break;
				case "ArtLayer":
				default:
					if(Target == "LayerSet" || layer.isBackgroundLayer){
						return;
					}
					break;
			}
			var currentName	= layer.name;
			if((!VisibleOnly || layer.visible) && filter_reg.test(currentName)){
				found	= true;
				var replaceName	= currentName.replace(replace_reg, replaceWord);
				var matchWords	= [RegExp.$1, RegExp.$2, RegExp.$3, RegExp.$4, RegExp.$5, RegExp.$6, RegExp.$7, RegExp.$8, RegExp.$9, RegExp.lastMatch, RegExp.leftContext, RegExp.rightContext, RegExp.lastParen];
				if(replaceName){
					var len	= MATCH_SIGNS.length;
					for(var i = 0; i < len; i++){
						replaceName	= replaceName.replace(MATCH_SIGNS[i], matchWords[i]);
					}
				}else{
					replaceName	= " ";
				}
				if(currentName != replaceName){
					result	= true;
					beforeVisible	= layer.visible;
					layer.name	= replaceName;
					if(layer.visible != beforeVisible){
						layer.visible	= beforeVisible;
					}
					addHistory(layer, currentName, replaceName);
					replaceLog_etx.text	+= currentName + "\t -> " + replaceName + NEW_LINE_ON_FS;
				}
			}
		}
		,data.AsSubLayerSets
		,eventHandler
	);

	if(!found){
		_config.alertAs(ERROR_NOT_FOUND);
	}else if(result){
		_config.alertAs(TITLE_RESULT);
	}else{
		_config.alertAs(ERROR_NOT_RESULT);
	}

};


///{} レイヤー名置換取り消し
function undoLayerNames(eventHandler, replaceLog_etx) {

	var history	= _config.global.history;
	initHistory();

	var layer;
	var beforeVisible;
	var len	= history.length;
	var max	= len - 1;
	for(var i = 0; i < len; i++){
		layer	= history[i].layer
		beforeVisible	= layer.visible;
		layer.name	= history[i].beforeName;
		addHistory(layer, history[i].afterName, history[i].beforeName);
		replaceLog_etx.text	+= history[i].afterName + "\t -> " + history[i].beforeName + NEW_LINE_ON_FS;
		eventHandler.info	= history[i].afterName;
		eventHandler.onProgress(Math.round(i / max * 100));
	}

	if(len){
		_config.alertAs(TITLE_UNDO_RESULT);
	}

};


