﻿//※【未完】＞身保存ドキュメント時にエラー
/**

///	ドキュメント内レイヤーを上から順にずらして整列するスクリプト

	制作：彩藤神楽	(http://www.re-sonance.com/)


	Copyright (C) 2007-2008 Saitoh Kagura, All Rights Reserved.

 */

const SCRIPT_TITLE	= "レイヤー一覧";
const VERSION		= "0.1.00";


///-------------------------------------------------------------
///	外部スクリプトファイル読み込み
//--------------------------------------------------------------
#include "./lib/Resonance.jsxinc"
#include "./lib/ScriptUtil.jsxinc"
#include "./lib/LayerUtil.jsxinc"
#include "./lib/ConfigDialog.jsxinc"


///-------------------------------------------------------------
///	グローバル
//--------------------------------------------------------------

//--> 基礎準備
#target photoshop
app.bringToFront();
const NEW_LINE	= Resonance.NEW_LINE;
const NEW_LINE2	= NEW_LINE + NEW_LINE;
_resonance		= new Resonance(SCRIPT_TITLE, VERSION);

///> ダイアログ用定数
const MESSAGE_COMPLETE			= "完了";
const MESSAGE_SAVE_FORMAT		= "保存時のファイル名";

///> ドキュメント用定数
const EXTRACT_DOCUMENT_PREFIX	= "レイヤー一覧[";
const EXTRACT_DOCUMENT_SUFFIX	= "]";
const EXTRACT_LAYER_NAME		= "レイヤー一覧";
const EXTRACT_EXTENSION			= ".psd";

const TEXT_TEMPLATE_LAYER_NAME	= "<list>";

///> 確認ダイアログ
const TITLE_EXTRACTION			= "レイヤー一覧抽出";
const CONFIRM_EXTRACTION_PREFIX	= "レイヤーを";
const CONFIRM_EXTRACTION_PREFIX2= "方向に敷き詰めて結合した画像を抽出します。" + NEW_LINE + "（レイヤーセット内の画像はそれと逆方向に整列します）";
const MESSAGE_SAVE_PATH_PREFIX	= NEW_LINE2 + "保存先: ";
const CONFIRM_EXTRACTION_SUFFIX	= NEW_LINE2 + "よろしいですか？" + NEW_LINE2;
const TITLE_RESULT				= "レイヤー一覧画像 抽出完了 ";
const MESSAGE_RESULT			= "レイヤーを敷き詰めた画像の抽出が完了しました。";

///> メッセージ
const ERROR_NOT_TARGET_LAYERS	= "対象レイヤーが存在しませんでした。";
const ERROR_NOT_TEXT_LAYERS		= "レイヤー名埋め込み用に指定されたテンプレートレイヤーがテキストレイヤーではありません。";

//> グローバルに扱う設定系オブジェクト
var _config;

///> 設定データ
var _configData	= {};
_configData.infoData	= {
	 _way				: "整列する方向"
	,Way				: ["横に整列(&R)", "縦に整列(&C)"]
	,VisibleOnly		: "表示レイヤーのみ対象にする(&V)"
	,LayerNameAffixed	: "レイヤー名を埋め込む。(&N)"
	,_LayerNameAffixed	: '　※レイヤー名を埋め込むには"' + TEXT_TEMPLATE_LAYER_NAME + '"という名前のテキストレイヤーが必要です。'
//	,SaveToSameDocument	: "抽出結果のPSDファイルを同フォルダに保存(&S)"
	,SaveToSameDocument	: "抽出PSDの自動保存"
	,_SaveFormatButton	: "保存名編集..."
};
_configData.helpData	= {
	 LayerNameAffixed	: '"' + TEXT_TEMPLATE_LAYER_NAME + '"という名前のテキストレイヤー設定に基づいて文字を埋め込みます。'
};
_configData.defaultData	= {
	 ScriptTitle		: SCRIPT_TITLE
	,ScriptVersion		: VERSION
	,Way				: 0
	,VisibleOnly		: true
	,LayerNameAffixed	: true
	,SaveToSameDocument	: false
	,SaveFormat			: "レイヤー一覧[<name>]"
};
_configData.listData	= {
	 Way	: {
		 row	: 0
		,column	: 1
	}
}
_configData.widthData	= {
	 "_way"	: 240
};
_configData.heightData	= {
};


//--> 本体実行
main();


///-------------------------------------------------------------
///	メインフロー関数
//--------------------------------------------------------------

///{} 本体
function main() {

	//--? 起動時チェック
	try{
		ScriptUtil.inspectDocumentExists();
		ScriptUtil.inspectPhotoshopVersion();
		ScriptUtil.inspectDocumentFormat();
		ScriptUtil.inspectLayersExists();
	}catch(e){
		_resonance.showError(e);
		return;
	}

	//--> 座標計測用に単位を一時的にPixelにする
	var originalRulerUnits	= preferences.rulerUnits;
	preferences.rulerUnits	= Units.PIXELS;

	try{

		mainFlow();

	}catch(e){
		_resonance.showError(e);
	}

	//--> 単位をオリジナルのものに戻す
	preferences.rulerUnits	= originalRulerUnits;

};


///{} メインフロー
function mainFlow() {

	//--> 設定読み込み
	loadConfig();

	//--> 設定ダイアログ表示
	if(_config.show()){

		//(!) OKの場合

		//--> レイヤーを敷き詰める
		formLayers();

	}

};


///{} 設定読み込みその編集用ダイアログを配置
function loadConfig() {

	//--> XMLデータとダイアログ設定を関連付けるクラスを生成
	_config	= new ConfigDialog(_configData);
	ScriptUtil.tries(_resonance.windowTitle, _config.connectXMLON, _config, [
		 _resonance.configFilePath
		,SCRIPT_TITLE
		,VERSION
	]);

	_config.title	= _resonance.windowTitle;

  ///{} ダイアログのレイアウトと設定データの対応を準備する
  _config.prepare	= function(){

	//> 保存先情報
//	this.global.saveName	= EXTRACT_DOCUMENT_PREFIX + _resonance.documentName + EXTRACT_DOCUMENT_SUFFIX;
//	this.global.savePath	= _resonance.documentParentPath + "/" + this.global.saveName + EXTRACT_EXTENSION;


	/// レイアウト

	const column_opt	= this.setOptions({orientation:"column", alignChildren:"left", alignment:"top"});
	const row_opt		= this.setOptions({orientation:"row"});

	//--> メインウィンドウ生成
	this.create();

	//--> メイングループ
	this.addGroup("_main", {orientation:"row", spacing:ConfigDialog.BROAD_SPACE});

	this.addGroup("_main/_frame", column_opt);

	this.addPanel("_main/_frame/_way", column_opt);
		this.addGroup("_main/_frame/_way/Way", column_opt);
			this.addRadioButtonItem();
			this.addRadioButtonItem();

	this.addGroup("_main/_frame/_config", column_opt);
		var affixed_cbx	= this.addCheckBox("LayerNameAffixed");
		this.addText("_LayerNameAffixed", undefined, {multiline:true}).enabled	= false;
		this.addCheckBox("VisibleOnly");
		this.addGroup("_main/_frame/_config/_saveFormat", row_opt);
			this.addCheckBox("SaveToSameDocument");
			this.addButton("_SaveFormatButton", undefined, "onClickSaveFormat");
			this.ascend();
		this.addConfirmLongCheckBox();
		this.addSpace();

	var button_grp	= this.addMainButton("_main/_button", column_opt, true, true);

	/// イベントハンドラ

	var eventListener	= {};

	//e{} OKボタンイベント
	eventListener.onClickOK	= function(conf, item){
		conf.global.saveName	= _resonance.replaceDocumentTag(_config.data.SaveFormat);
		conf.global.savePath	= _resonance.documentParentPath + "/" + conf.global.saveName + EXTRACT_EXTENSION;
		var way		= (conf.data.Way == conf.listData.Way.column) ? "縦" : "横";
		var path	= "";
		if(conf.data.SaveToSameDocument){
			var save_file	= new File(conf.global.savePath);
			path	= MESSAGE_SAVE_PATH_PREFIX + '"' + save_file.fsName + '"';
		}
		conf.confirmMessage	= CONFIRM_EXTRACTION_PREFIX + way +
			CONFIRM_EXTRACTION_PREFIX2 + path + CONFIRM_EXTRACTION_SUFFIX, TITLE_EXTRACTION;
	};

	///e{} 自動保存ファイル名編集ボタンイベント
	eventListener.onClickSaveFormat	= function(conf, item){
		conf.data.SaveFormat	= _resonance.editDocumentInfoTemplate(conf.data.SaveFormat, MESSAGE_SAVE_FORMAT);
	};

	//e{} エラー表示イベント
	eventListener.onError	= function(conf, item, e){
		_resonance.showError(e);
	};

	//--> イベントリスナーを登録
	this.setListener(eventListener);

  };

};


///{:e} レイヤーを敷き詰める
function formLayers() {

	// 各種設定値・定数

	var data				= _config.data;
	var VisibleOnly			= data.VisibleOnly;
	var LayerNameAffixed	= data.LayerNameAffixed;
	var isColumn			= (data.Way == _config.listData.Way.column);

	var getPositionData		= LayerUtil.getPositionData;
	var getByNameInAllLayers= LayerUtil.getByNameInAllLayers;
	var insertText			= LayerUtil.insertText;
	var adjustOnSelecting	= LayerUtil.adjustOnSelecting;

	var RESIZE_ANCHOR		= AnchorPosition.TOPLEFT;
	var TEMP_CLOSE_OPTION	= SaveOptions.DONOTSAVECHANGES;
	var MERGE_LAYER_PLACE	= ElementPlacement.PLACEATEND;

	//> 各種作業用PSD
	var temp_doc;
	var base_doc		= activeDocument;
	var merge_doc		= LayerUtil.duplicateEmptyDocument(_config.global.saveName);
	var default_layer	= merge_doc.layers[0];
	activeDocument		= base_doc;

	//{?} 既にレイヤー名を埋め込んでいるか判定
	var processedLayers	= [];
	var isProcessed	= function(layer){
		var len	= processedLayers.length;
		for(var i = 0; i < len; i++){
			if(processedLayers[i] == layer){
				return true;
			}
		}
		return false;
	};
	//{} PSD内のレイヤーの分だけドキュメントサイズを一方向に拡大してレイヤーを順に並べる
	var enlargeDocument	= function(document, isColumn, layerSet){
		//{?} 一覧用の有効レイヤーか
		var isEnabledLayer	= function(layer){
			return !(
				(
					(VisibleOnly && !layer.visible)
					||
					(layer.name == TEXT_TEMPLATE_LAYER_NAME)
				)
				||
				(layer.kind == LayerKindTEXT && layer != tpl_layer)
			);
		}
		activeDocument	= document;
		var LayerKindTEXT	= LayerKind.TEXT;
		var selection	= document.selection;
		var width		= document.width;
		var height		= document.height;
		var resizeWidth	= width;
		var resizeHeight= height;
		var prevWidth	= width;
		var prevHeight	= height;
		var layer;
		var layers		= layerSet ? layerSet.artLayers : document.artLayers;
		var tpl_layer	= LayerNameAffixed ? getByNameInAllLayers(document, TEXT_TEMPLATE_LAYER_NAME) : null;
		var count		= 0;
		var i;
		var len			= layers.length;
		//{--} レイヤー名埋め込み
		if(LayerNameAffixed && tpl_layer){
			for(i = 0; i < len; i++){
				layer	= layers[i];
				//--? レイヤー名挿入
				if(isEnabledLayer(layer) && !isProcessed(layer)){
					document.activeLayer	= layer;
					insertText(layer, tpl_layer, layer.name);
				}
			}
		}
		//--> はみ出す部分を削除
		document.crop([0, 0, width, height]);
		//{--} レイヤー整列
		for(i = 0; i < len; i++){
			layer	= layers[i];
			if(!isEnabledLayer(layer)){
				layer.visible	= false;
				continue;
			}
			count++;
			document.activeLayer	= layer;
			//--> 整列
			if(count == 1){
				continue;
			}
			if(isColumn){
				resizeHeight	+= height;
			}else{
				resizeWidth		+= width;
			}
			document.resizeCanvas(resizeWidth, resizeHeight, RESIZE_ANCHOR);
			if(isColumn){
				//(!) 縦に整列
				selection.select([
					 [0, prevHeight]
					,[width, prevHeight]
					,[width, resizeHeight]
					,[0, resizeHeight]
					,[0, prevHeight]
				]);
				adjustOnSelecting(null, "top");
			}else{
				//(!) 横に整列
				selection.select([
					 [prevWidth, 0]
					,[resizeWidth, 0]
					,[resizeWidth, height]
					,[prevWidth, height]
					,[prevWidth, 0]
				]);
				adjustOnSelecting("left");
			}
			prevWidth	= resizeWidth;
			prevHeight	= resizeHeight;
			selection.deselect();
		}
		if(tpl_layer){
			tpl_layer.remove();
		}
		if(!count){
			return null;
		}else if(count > 1){
			document.mergeVisibleLayers();
		}
		//--? 結合先にゴミが残るので非表示レイヤーを削除
		result_layers	= document.layers;
		var max	= result_layers.length - 1;
		if(max >= 0){
			for(var j = max; j >= 0; j--){
				if(!result_layers[j].visible){
					result_layers[j].remove();
				}
			}
		}
		return document.activeLayer;
	};

	//{--} まずレイヤーセット内の画像をまとめて結合用PSDに渡す・アートレイヤーはそのまま渡す
	var template_layer	= getByNameInAllLayers(base_doc, TEXT_TEMPLATE_LAYER_NAME);
	var nameInserted	= Boolean(LayerNameAffixed && template_layer);
	if(nameInserted && template_layer.kind != LayerKind.TEXT){
		throw new Error(ERROR_NOT_TEXT_LAYERS);
	}
	var maxWidth		= base_doc.width;
	var maxHeight		= base_doc.height;
	var layer;
	var layers			= base_doc.layers;
	var merge_layer;
	var clone_layerSet;
	var clone_layer;
	var pos;
	var len	= layers.length;
	for(var i = 0; i < len; i++){
		layer	= layers[i];
		if((VisibleOnly && !layer.visible) && layer != template_layer){
			continue;
		}

		activeDocument	= base_doc;
		if(layer.typename == "LayerSet"){
			//--> 空のテンポラリPSDにレイヤーセットをコピーして設定と逆方向に整列
			temp_doc	= LayerUtil.duplicateEmptyDocument();
			activeDocument	= base_doc;
			clone_layerSet	= layer.duplicate(temp_doc, MERGE_LAYER_PLACE);
			if(nameInserted){
				template_layer.duplicate(temp_doc, MERGE_LAYER_PLACE);
			}
			clone_layer		= enlargeDocument(temp_doc, !isColumn, clone_layerSet);
			if(!clone_layer){
				//(!) 中身が空だった場合
				temp_doc.close(TEMP_CLOSE_OPTION);
				continue;
			}
			//--> 整形したレイヤーを結合先PSDにコピーして基準座標に整列
			merge_layer	= clone_layer.duplicate(merge_doc, MERGE_LAYER_PLACE);
			processedLayers.push(merge_layer);
			temp_doc.close(TEMP_CLOSE_OPTION);
			activeDocument	= merge_doc;
			merge_doc.activeLayer	= merge_layer;
			merge_doc.selection.selectAll();
			adjustOnSelecting("left", "top");
			merge_doc.selection.deselect();
			//--? 結合先PSDのリサイズ情報を更新
			pos	= getPositionData(merge_layer);
			if(pos.xEnd > maxWidth){
				maxWidth	= pos.xEnd;
			}
			if(pos.yEnd > maxHeight){
				maxHeight	= pos.yEnd;
			}
		}else{
			layer.duplicate(merge_doc, MERGE_LAYER_PLACE);
		}
	}

	//--> 結合先PSDをリサイズ＆整列
	if(merge_doc.layers.length == 1){
		merge_doc.close(TEMP_CLOSE_OPTION);
		throw new Error(ERROR_NOT_TARGET_LAYERS);
	}

	activeDocument	= merge_doc;
	default_layer.remove();
	merge_doc.resizeCanvas(maxWidth, maxHeight, RESIZE_ANCHOR);
	var extract_layer	= enlargeDocument(merge_doc, isColumn);

	if(!extract_layer){
		merge_doc.close(TEMP_CLOSE_OPTION);
		throw new Error(ERROR_NOT_TARGET_LAYERS);
	}
	extract_layer.name	= EXTRACT_LAYER_NAME;

	//--? 抽出元ドキュメントと同フォルダに書き出し
	var path	= "";
	if(_config.data.SaveToSameDocument){
		var save_file	= new File(_config.global.savePath);
		merge_doc.saveAs(save_file, new PhotoshopSaveOptions(), false);
		path	= MESSAGE_SAVE_PATH_PREFIX + '"' + save_file.fsName + '"';
	}

	_config.alertAs(MESSAGE_RESULT + path, TITLE_RESULT);

};


