﻿//※【未完】＞素材書き出しの設定ファイルがの反映がうまくない
/**

///	ダイアログを表示しない直実行設定の切り換え用スクリプト

	制作：彩藤神楽	(http://www.re-sonance.com/)


	Copyright (C) 2007-2008 Saitoh Kagura, All Rights Reserved.

 */

const SCRIPT_TITLE	= "スクリプト管理";
const VERSION		= "0.1.00";


///-------------------------------------------------------------
///	外部スクリプトファイル読み込み
//--------------------------------------------------------------
#include "./lib/Resonance.jsxinc"
#include "./lib/ScriptUtil.jsxinc"
#include "./lib/ConfigDialog.jsxinc"


///-------------------------------------------------------------
///	グローバル
//--------------------------------------------------------------

//--> 基礎準備
#target photoshop
app.bringToFront();
const NEW_LINE	= Resonance.NEW_LINE;
const NEW_LINE2	= NEW_LINE + NEW_LINE;
_resonance		= new Resonance(SCRIPT_TITLE, VERSION);

//> 素材書き出しスクリプトのメタデータ接頭辞
const LAYERS_EXPORT_SCRIPT_NAME		= "素材書き出し";
const LAYERS_EXPORT_SCRIPT_SYMBOL	= Resonance.symbol[LAYERS_EXPORT_SCRIPT_NAME];

///> ダイアログ用定数
const CONFIRM_SUFFIX	= NEW_LINE2 + "よろしいですか？";
const CONFIRM_EXPORT	= "設定データ群を任意の場所にフォルダごとコピーします。" + NEW_LINE + 'コピーしたデータは後で"インポート"する事で復元できます。' + CONFIRM_SUFFIX;
const CONFIRM_IMPORT	= "設定データ群をフォルダごと取り込みます。" + NEW_LINE + "現在の設定はすべて上書きされます。" + CONFIRM_SUFFIX;
const CONFIRM_REMOVE_ALL= "現在有効なライブラリスクリプトの設定データを一斉に削除します。" + NEW_LINE2 + "すべての設定は初期値に戻ります。" + NEW_LINE + "この処理は後で取り消しできません。" + CONFIRM_SUFFIX;
const MESSAGE_RESULT_EXPORT	= "ライブラリスクリプトの設定データをエクスポートしました。";
const MESSAGE_RESULT_IMPORT	= "ライブラリスクリプトの設定データをインポートしました。";

///> ドキュメント名を含む場合の文字数の表記上の限界
const MAX_DOCUMENT_NAME			= 28;
const MAX_DOCUMENT_NAME_SUFFIX	= "~]";

//> グローバルに扱う設定系オブジェクト
var _config;

///> 設定データ
var _configData	= {};
_configData.infoData	= {
	 Directlys	: {
		 _panel				: "設定ダイアログを表示するスクリプト"
		,ColorManage		: "色管理"
		,VariationManage	: "差分管理"
		,LayerExport		: LAYERS_EXPORT_SCRIPT_NAME + " ...[*]"
		,_LayerExport		: LAYERS_EXPORT_SCRIPT_NAME
		,FileJoin			: "ファイル連結"
		,LayerSort			: "レイヤー並び替え"
		,LayerSearch		: "レイヤー検索"
		,LayerList			: "レイヤー一覧"
		,LayerGroup			: "レイヤー分類"
		,LayerRename		: "レイヤー名連番化"
		,ActionBatch		: "アクション一括適用"
	}
	,_path				: "設定ファイル保存先フォルダ"
	,_export			: "エクスポート(&E)"
	,_import			: "インポート(&I)"
	,_removeAll			: "すべての設定データを削除する"
};
_configData.defaultData	= {
	 ScriptTitle	: SCRIPT_TITLE
	,ScriptVersion	: VERSION
	,BackupPath		: ""
	,Directlys	: {
		 LayerExport	: true
		,ColorManage	: true
		,VariationManage: true
		,FileJoin		: true
		,LayerSort		: true
		,LayerSearch	: true
		,LayerList		: true
		,LayerGroup		: true
		,LayerRename	: true
		,ActionBatch	: true
	}
	,Enableds	: {
		 LayerExport	: false
		,ColorManage	: true
		,VariationManage: true
		,FileJoin		: true
		,LayerSort		: true
		,LayerSearch	: true
		,LayerList		: true
		,LayerGroup		: true
		,LayerRename	: true
		,ActionBatch	: true
	}
};
_configData.widthData	= {
	 Directlys	: {
		 "_left,_right"	: 160
		,_panel	: 360
	 }
	,_configPath	: 320
	,"_path,_hr"	: 360
};
_configData.heightData	= {
	 _configPath	: 48
};


//--> 本体実行
main();


///-------------------------------------------------------------
///	メインフロー関数
//--------------------------------------------------------------

///{} 本体
function main() {

	//--? 起動時チェック
	try{
		ScriptUtil.inspectPhotoshopVersion();
	}catch(e){
		_resonance.showError(e);
		return;
	}

	try{

		mainFlow();

	}catch(e){
		_resonance.showError(e);
	}

};


///{} メインフロー
function mainFlow() {

	//--> 設定読み込み
	loadConfig();

	//--> 設定ダイアログ表示
	if(_config.show()){

		//(!) OKの場合

		//--> 直実行設定切り換え
		switchDirectlysSetting();

	}

};


///{} 設定読み込みその編集用ダイアログを配置
function loadConfig() {

	//--> XMLデータとダイアログ設定を関連付けるクラスを生成
	_config	= new ConfigDialog(_configData);
	ScriptUtil.tries(_resonance.windowTitle, _config.connectXMLON, _config, [
		 _resonance.configFilePath
		,SCRIPT_TITLE
		,VERSION
	]);

	_config.title	= _resonance.windowTitle;

  _config.prepare	= function(){

	var eventListener	= {};

	/// レイアウト

	var Directlys		=  _config.infoData.Directlys;

	const column_opt	= this.setOptions({orientation:"column", alignChildren:"left", alignment:"top"});
	const row_opt		= this.setOptions({orientation:"row", alignment:"right"});

	//--> メインウィンドウ生成
	this.create();

	//--> メイングループ
	this.addGroup("_main", column_opt);

	this.addGroup("_main/_util", row_opt);
		this.addButton("_export", undefined, "onClickExport");
		this.addButton("_import", undefined, "onClickImport");
		this.addButton("_removeAll", undefined, "onClickRemoveAll");
		this.ascend();
	this.addHorizon("_hr");
	this.addSpace();

	this.addGroup("_main/Directlys", column_opt);

		this.addPanel("_main/Directlys/_panel", column_opt);
			var layEx_cbx	= this.addCheckBox("LayerExport");
			var layExEnabled	= (documents.length > 0);
			if(layExEnabled){
				var parentName	= _resonance.documentParentName;	//activeDocument, LAYERS_EXPORT_SCRIPT_SYMBOL
				var docName		= _resonance.configFileName;	//Directlys._LayerExport, activeDocument, LAYERS_EXPORT_SCRIPT_SYMBOL
				var doc_file	= new File(_resonance.configFilePath);
				layExEnabled	= doc_file.exists;
				if(layExEnabled){
					layEx_cbx.text	= layEx_cbx.text.replace(/\*/, parentName);
					if(layEx_cbx.text.length > MAX_DOCUMENT_NAME){
						layEx_cbx.text	= layEx_cbx.text.substring(0, MAX_DOCUMENT_NAME) + MAX_DOCUMENT_NAME_SUFFIX;
					}
				}
			}
			_config.data.Enableds.LayerExport	= layEx_cbx.enabled	= layExEnabled;

			this.addGroup("_main/Directlys/_panel/_group", row_opt);
				this.addGroup("_main/Directlys/_panel/_group/_left", column_opt);
					this.addCheckBox("ColorManage");
					this.addCheckBox("VariationManage");
					this.addCheckBox("FileJoin");
					this.addCheckBox("ActionBatch");

				this.addGroup("_main/Directlys/_panel/_group/_right", column_opt);
					this.addCheckBox("LayerSort");
					this.addCheckBox("LayerSearch");
					this.addCheckBox("LayerList");
					this.addCheckBox("LayerGroup");
					this.addCheckBox("LayerRename");

	this.addMainButton("_main/_button", row_opt, false, true);


	//{} バックアップ先親フォルダを保存
	var saveBackupPath = function(folder){
		_config.data.BackupPath	= folder.fsName;
		_config.save();
	};


	//e{} 設定ファイル書き出しボタンイベント
	eventListener.onClickExport	= function(conf, item){
		if(conf.confirmAs(CONFIRM_EXPORT)){
			var result_folder	= _resonance.exportConfigFiles(conf.data.BackupPath);
			if(result_folder){
				conf.alertAs(MESSAGE_RESULT_EXPORT + NEW_LINE2 + '"' + result_folder.fsName + '"');
				saveBackupPath(result_folder.parent);
			}
		}
	};

	//e{} 設定ファイル取り込みボタンイベント
	eventListener.onClickImport	= function(conf, item){
		if(conf.confirmAs(CONFIRM_IMPORT)){
			var result_folder	= _resonance.importConfigFiles(conf.data.BackupPath);
			if(result_folder){
				conf.alertAs(MESSAGE_RESULT_IMPORT);
				saveBackupPath(result_folder.parent);
			}
		}
	}

	//e{} 設定ファイル全消去ボタンイベント
	eventListener.onClickRemoveAll	= function(conf, item){
		if(conf.confirmAs(CONFIRM_REMOVE_ALL)){
			_resonance.removeConfigFiles();
			conf.reset();
		}
	};


	//e{} エラー表示イベント
	eventListener.onError	= function(conf, item, e){
		alert("<onError>" + e + "\n" + dump(item), Resonance.title.ERROR, true);	//※【未完】
	};

	//--> イベントリスナーを登録
	this.setListener(eventListener);

  };

};


///{} 直実行設定切り替え
function switchDirectlysSetting() {

	var infoData	= _config.infoData.Directlys;
	var enabledData = _config.data.Enableds;
	var valueData	= _config.data.Directlys;
	var targetName;
	var cd;
	var res;
//var log=""
	for(var i in enabledData){
		if(!enabledData[i]){
			continue;
		}
		targetName	= infoData[(infoData[i].indexOf("*") == -1 ? "" : "_") + i];
		//--> 設定接続
		cd	= new ConfigDialog();
		res	= new Resonance(targetName, null, (targetName == LAYERS_EXPORT_SCRIPT_NAME));
		ScriptUtil.tries(res.windowTitle, cd.connectXMLON, cd, [res.configFilePath]);
		//--> 直実行フラグ更新
		cd.data.directly	= !valueData[i];
//log+=cd.data.directly+ "\t" +targetName+ "\t" +res.configFilePath.replace(/^.*\\/, "")+"\n";
		//--> 設定保存
		ScriptUtil.tries(res.windowTitle, cd.saveData, cd);
	}
//alert(log);
};


