﻿//※【未完】＞やっぱ不便なので、出力ファイル名のレイヤー名部分もタグ式で対応
/**

///	素材書き出しスクリプト

	制作：彩藤神楽	(http://www.re-sonance.com/)


	Copyright (C) 2007-2008 Saitoh Kagura, All Rights Reserved.

 */

const SCRIPT_TITLE	= "素材書き出し";
const VERSION		= "0.1.00";


///-------------------------------------------------------------
///	外部スクリプトファイル読み込み
//--------------------------------------------------------------
#include "./lib/Resonance.jsxinc"
#include "./lib/ScriptUtil.jsxinc"
#include "./lib/LayerUtil.jsxinc"
#include "./lib/FileUtil.jsxinc"
#include "./lib/StringUtil.jsxinc"
#include "./lib/ConfigDialog.jsxinc"
#include "./lib/TagConverter.jsxinc"


///-------------------------------------------------------------
///	グローバル
//--------------------------------------------------------------

//--> 基礎準備
#target photoshop
app.bringToFront();
const NEW_LINE	= Resonance.NEW_LINE;
const NEW_LINE2	= NEW_LINE + NEW_LINE;
const INDENT	= Resonance.INDENT;
const INDENT2	= INDENT + INDENT;
_resonance		= new Resonance(SCRIPT_TITLE, VERSION, true);

///> ファイル保存用定数
const EXCEPT_PREFIX				= "/*";		//> レイヤー名の先頭にこの文字があると書き出し対象にならない
const THROUGH_PREFIX			= "//";		//> レイヤー名の先頭にこの文字があると名前を追記しない
const GROUP_DELIMITER			= "|";		//> グループ情報記記号・レイヤーセットも強制的に書き出し対象になる
const SHADE_PREFIX				= "*";		//> 名前の先頭にこの文字があると書き出し対象にされていても書き出されない
const REG_COMMENT				= "\/\/";	//> レイヤー名のこれ以降はコメントアウトされる
const FILE_TYPE_REG				= /\((png|gif|jpg|jpeg|bmp|psd)\)/i;	//> レイヤー名からファイルタイプを取得
const FILE_TYPE_EXTRACT_REG		= /[\(\)]/g;	//> ファイルタイプ記号から余分な文字を除外
const REG_GROUP_NAME			= "[^\\|]+";//> レイヤー名からグループを抽出する正規表現（/g）
const REG_GROUP_DELIMITER		= "[\\|]";	//> レイヤー名からグループ記号を抽出する正規表現（/g）
const REG_SHADE					= "^\\*";	//> 対象除外レイヤー名正規表現
const FILE_NAME_REPLACE_CHAR	= "@";		//> ファイル名に使えない文字を変換する際の代替文字
const SPACE_REG					= /[ ]/g;	//> いろいろと紛らわしいので半角スペースはファイル名に使えない
const FOLDER_SUFFIX_REG			= /[\\\/]$/;	//> 末尾がフォルダ階層の区切り記号である
const PNG_EXTENSION				= ".png";
const BMP_EXTENSION				= ".bmp";
const JPG_EXTENSION				= ".jpg";
const JPEG_EXTENSION			= ".jpeg";
const GIF_EXTENSION				= ".gif";
const PSD_EXTENSION				= ".psd";
const XML_ROOT_NODE				= "Config";
const TEMPORARY_LAYER_NAME		= "__temporaryLayer__";	//> テンポラリPSD生成時の初期レイヤー名
const UNSAVED_DOCUMENT_NAME		= "（未保存ドキュメント）";	//> 未保存ドキュメントの共通名

///> 書き出しログ書式設定用定数
//> 共通タグ
const NEW_LINE_TAG			= TagConverter.tag.NEW_LINE;
const INDENT_TAG			= TagConverter.tag.INDENT;
const COUNT_TAG				= "<ct>";
const COUNT2_TAG			= "<cv>";
const BASE_TAG				= "<base>";
const PATH_TAG				= "<path>";
const ID_TAG				= "<id>";
const GUIDE_TAG				= "<guide>";
//> 個別タグ
const NAME_TAG				= "<name>";
const SUB_TAG				= "<sub>";
const TYPE_TAG				= "<type>";
const X_TAG					= "<x>";
const Y_TAG					= "<y>";
const X2_TAG				= "<x2>";
const Y2_TAG				= "<y2>";
const WIDTH_TAG				= "<w>";
const HEIGHT_TAG			= "<h>";
const NOTE_TAG				= "<note>";
const FULL_NOTE_TAG			= "<fullnote>";

//> ファイルID取得用
const ID_GUIDE_REG			= /^.+?\[|\].+?$/;
const ID_REG				= /#.*/;
const GUIDE_REG				= /^.*?#/;

//> 注釈タグ直接変換用
const NOTE_TAG_REG			= /<note>/i;
const FULL_NOTE_TAG_REG		= /<fullnote>/i;

//> ボタン・メッセージ
const BUTTON_GET_TARGET			= "対象レイヤーを取得(&G)";
const BUTTON_SAVE_ENABLED		= "設定を保存する(&S)";
const BUTTON_RESET				= "設定の初期化(&F)";
const TITLE_RESET				= "設定の初期化";
const MESSAGE_CONFIRM_RESET		= "すべての設定項目を標準の値に戻します。" + NEW_LINE2 + "よろしいですか？" + NEW_LINE2;
const MESSAGE_RESULT_RESET		= "すべての設定を初期化しました。"

///> 書き出し結果ダイアログ用
const TITLE_RESULT					= "レイヤー書き出し完了 ";
const MESSAGE_RESULT_FORMAT			= "ファイル形式";
const MESSAGE_RESULT_ALL_LAYERS		= "対象レイヤー数";
const MESSAGE_RESULT_SAVED_LAYERS	= "書き出しレイヤー数";
const MESSAGE_RESULT_EMPTY_LAYERS	= "空・除外レイヤー数";

///> 書き出しログ用定数
const LOG_FILE_NAME				= "書出ログ";
const LOG_FILE_NAME_PREFIX		= LOG_FILE_NAME + "[";
const LOG_FILE_NAME_SUFFIX		= "]";

///> バックアップ用定数
const BACKUP_FOLDER_PREFIX		= "バックアップ[";
const BACKUP_FOLDER_SUFFIX		= "]";

///> カウンタ用定数
const COUNT_PREFIX				= "#";
const COUNT_MAX_VALUE			= 99999999;

///> 設定ダイアログデフォルト値用定数

//> 切り抜き
const INDEX_NOT_CROP		= 0;
const INDEX_CROP_AS_PARENT	= 1;
const INDEX_CROP_AS_EACH	= 2;

//> 拡大・縮小
const INDEX_RESAMPLE_BICUBIC= 2;
const RESAMPLE_LIST			= [
	 ResampleMethod.NEARESTNEIGHBOR
	,ResampleMethod.BILINEAR
	,ResampleMethod.BICUBIC
	,ResampleMethod.BICUBICSMOOTHER
	,ResampleMethod.BICUBICSHARPER
];
const TEXT_RESAMPLE_LIST		= [
	 "ニアレストネイバー法"
	,"バイリニア法"
	,"バイキュービック法"
	,"バイキュービック法(滑らか)"
	,"バイキュービック法(シャープ)"
];

//> JPEGオプション
const INDEX_STANDARD_JPEG		= 0;
const INDEX_OPTIMIZED_JPEG		= 1;
const INDEX_PROGRESSIVE_JPEG	= 2;
const JPEG_FORMAT_LIST			= [
	 FormatOptions.STANDARDBASELINE
	,FormatOptions.OPTIMIZEDBASELINE
	,FormatOptions.PROGRESSIVE
];
const TEXT_JPEG_FORMAT_LIST	= [
	 "ベースライン（標準）(&S)"
	,"ベースライン（最適化）(&O)"
	,"プログレッシブ(&P)"
];

//> 更新管理
const INDEX_BACKUP_CONFIRM		= 0;
const INDEX_BACKUP_OVER_WRITE	= 1;
const INDEX_BACKUP_NONE			= 2;
const INDEX_BACKUP_FOLDER		= 3;

///> 書き出しログ書式設定ダイアログ用定数
const INDEX_LOG_DONOT_SAVE		= 0;
const INDEX_LOG_WITH_TARGET		= 1;
const INDEX_LOG_WITH_DOCUMENT	= 2;
const INDEX_LOG_WITH_COUNT		= 2;
const TITLE_LOG_HELP			= "書き出しログ書式ヘルプ";
const PANEL_LOG_GLOBAL_HELP		= "共通タグ";
const PANEL_LOG_ITEM_HELP		= "個別タグ（レイヤー毎の情報に置換）";
const PANEL_LOG_DATE_HELP		= "日付・時刻タグ";
const TEXT_LOG_NOTE_HELP		= "※『先頭:』『末尾:』内には改行タグと水平タブタグのみ有効　　※個別タグは『個別:』内専用";
const TEXT_LOG_GLOBAL_HELP		= FileUtil.adjustNewLineCode(
	"書き出しカウント" + INDENT + COUNT_TAG + 
	NEW_LINE + "書き出しカウント数" + INDENT + COUNT2_TAG + 
	NEW_LINE + "書き出し先フォルダ" + INDENT + PATH_TAG + 
	NEW_LINE + "書き出し元ファイル" + INDENT + BASE_TAG + 
	NEW_LINE + "改行" + INDENT2 + NEW_LINE_TAG +
	NEW_LINE + "水平タブ" + INDENT2 + INDENT_TAG
);
const TEXT_LOG_ITEM_HELP		= FileUtil.adjustNewLineCode(
	NEW_LINE2 + "書き出しファイル名" + INDENT + NAME_TAG + 
	NEW_LINE + "サブフォルダ名" + INDENT + SUB_TAG +
	NEW_LINE + "ファイル拡張子" + INDENT + TYPE_TAG +
	NEW_LINE +
	NEW_LINE + "左端座標" + INDENT + X_TAG +
	NEW_LINE + "上端座標" + INDENT + Y_TAG +
	NEW_LINE +
	NEW_LINE + "右端座標" + INDENT + X2_TAG +
	NEW_LINE + "下端座標" + INDENT + Y2_TAG +
	NEW_LINE +
	NEW_LINE + "横幅" + INDENT2 + WIDTH_TAG +
	NEW_LINE + "縦幅" + INDENT2 + HEIGHT_TAG +
	NEW_LINE +
	NEW_LINE + "注釈" + INDENT2 + NOTE_TAG + NEW_LINE + '※（"注釈"はレイヤー名の"' + THROUGH_PREFIX + '"以降の文字）' +
	NEW_LINE + "注釈" + INDENT2 + FULL_NOTE_TAG + NEW_LINE + '※（親レイヤーセット階層も反映した注釈）'
);
var tag	= TagConverter.tag;
const TEXT_LOG_DATE_HELP		= FileUtil.adjustNewLineCode(
	"日時フルセット" + INDENT + tag.FULL_DATE + 
	NEW_LINE + "年/月/日" + INDENT2 + tag.DATE + 
	NEW_LINE + "時:分:秒" + INDENT2 + tag.TIME + 
	NEW_LINE + "曜日" + INDENT2 + tag.FULL_WEEK + 
	NEW_LINE + "曜日（略称）" + INDENT + tag.WEEK + 
	NEW_LINE + "年（４桁）" + INDENT2 + tag.FULL_YEAR + 
	NEW_LINE + "年（２桁）" + INDENT2 + tag.YEAR + 
	NEW_LINE + "月" + INDENT2 + tag.MONTH + 
	NEW_LINE + "日" + INDENT2 + tag.DAY + 
	NEW_LINE + "時" + INDENT2 + tag.HOUR + 
	NEW_LINE + "分" + INDENT2 + tag.MINUTE + 
	NEW_LINE + "秒" + INDENT2 + tag.SECOND +
	NEW_LINE + "ローカル" + tag.FULL_DATE + INDENT + tag.FULL_DATE2 + 
	NEW_LINE + "ローカル" + tag.DATE + INDENT + tag.DATE2 + 
	NEW_LINE + "ローカル" + tag.TIME + INDENT + tag.TIME2 + 
	NEW_LINE + "ローカル" + tag.FULL_WEEK + INDENT + tag.FULL_WEEK2 + 
	NEW_LINE + "ローカル" + tag.WEEK + INDENT + tag.WEEK2 + 
	NEW_LINE + "基本日時情報" + INDENT + tag.PLAIN_DATE
);

//> プリセット
const DEFAULT_LOG_HEAD		= "";
const DEFAULT_LOG_TOP		= NEW_LINE_TAG + "---------------- [" + COUNT_TAG + "] " + TagConverter.tag.FULL_DATE + " ----------------" + NEW_LINE_TAG +
	"【書き出し元】" + INDENT_TAG + BASE_TAG + NEW_LINE_TAG +
	"【書き出し先】" + INDENT_TAG + PATH_TAG + NEW_LINE_TAG +
	NEW_LINE_TAG;
const DEFAULT_LOG_BOTTOM	= NEW_LINE_TAG;
const DEFAULT_LOG_FOOT		= "";
const HTML_LOG_HEAD			= '<html><n><head><n><title>' + LOG_FILE_NAME + '</title><n><style><!--img{border:1px #CCC solid;}--></style>' + NEW_LINE_TAG + '</head><n><body><n>';
const HTML_LOG_TOP			= NEW_LINE_TAG + "<h1>" + COUNT_TAG + "</h1>" + NEW_LINE_TAG +
	"<h3>" + TagConverter.tag.FULL_DATE + "</h3>" + NEW_LINE_TAG +
	"<ul><li>【書き出し元】" + INDENT_TAG + BASE_TAG + "</li>" + NEW_LINE_TAG + 
	"<li>【書き出し先】" + INDENT_TAG + PATH_TAG + "</li></ul>" + NEW_LINE_TAG + NEW_LINE_TAG;
const HTML_LOG_ITEM			= NAME_TAG + TYPE_TAG + '  (x=' + X_TAG + ', y=' + Y_TAG + ')<br />' + NEW_LINE_TAG +
	'<img src="./' + SUB_TAG + NAME_TAG + TYPE_TAG + '" width="' + WIDTH_TAG + '" height="' + HEIGHT_TAG + '" alt="' + NOTE_TAG + '" />' + NEW_LINE_TAG + '<br />' + NEW_LINE_TAG;
const HTML_LOG_BOTTOM		= NEW_LINE_TAG + "<hr />" + NEW_LINE_TAG;
const HTML_LOG_FOOT			= '<n></body><n></html>';
const CSV_LOG_HEAD			= "書出No.,階層,ファイル名,X座標,Y座標,横幅,縦幅,日付,時刻,注釈,書出先,書出元" + NEW_LINE_TAG;
const DEFAULT_LOG_ITEM		= "(x:" + X_TAG + "," + INDENT_TAG + "y:" + Y_TAG + ")" + INDENT_TAG + NAME_TAG + TYPE_TAG + NEW_LINE_TAG;
const CSV_LOG_BODY			= COUNT2_TAG + ',"' + SUB_TAG + '","' + NAME_TAG + TYPE_TAG + '",' + X_TAG + ',' + Y_TAG  + ',' + WIDTH_TAG + ',' + HEIGHT_TAG + ',"' + TagConverter.tag.DATE + '","' + TagConverter.tag.TIME + '","' + NOTE_TAG + '","' + PATH_TAG + '","' + BASE_TAG + '"' + NEW_LINE_TAG;

///> ダイアログ用定数


const TITLE_LOG_FORM			= "書き出しログ：組み込み書式の適用";
const CONFIRM_LOG_FORM_PREFIX	= "『";
const CONFIRM_LOG_FORM_SUFFIX	= "書式設定』" + NEW_LINE2 + "現在の書式をこの設定で置き換えますか？" + NEW_LINE2;
const CONFIRM_EXPORT			= NEW_LINE2 + "この書き出し形式で対象レイヤーを書き出します" + NEW_LINE + "よろしいですか？" + NEW_LINE2;
const CONFIRM_CONTINUE			= NEW_LINE2 + "処理を続行しますか？" + NEW_LINE;
const CONFIRM_CAUTION_PREFIX	= "警告: ";
const ALERT_CANCEL				= "キャンセル: 書き出し処理を中止します。";

///> エラーメッセージ定数
const ERROR_FOLDER_NOT_EXIST	= "書き出し先のフォルダが存在しないため処理を中止しました。";
const ERROR_NOT_TARGET_LAYERS	= "書き出し対象レイヤーがありません。";

//> グローバルに扱う設定系オブジェクト
var _config;				//> 設定管理ダイアログ＆設定データ
var _configData		= {};	//> 設定データ基準値

//> 設定データメニュー
const INDEX_TARGET_LAYERS	= 0;
const INDEX_SAVE_FORMAT		= 1;
_configData.groupData	= {
	 TargetLayer	: "対象レイヤー"
	,SaveFormat		: "ファイル形式"
	,JpegFormat		: "JPEGオプション"
	,CropInBounds	: "切り抜き形式"
	,Resize			: "拡大・縮小"
	,FixedLayer		: "表示形式"
	,Backup			: "更新管理"
	,Counter		: "カウンタ設定"
	,Log			: "ログファイル"
	,Options		: "その他"
};

//> 設定データ表示テキスト
_configData.infoData	= {
	//> 対象レイヤー
	 TargetLayer	: {
		 VisibleOnly		: "表示レイヤーのみ対象にする(&V)"
		,Included			: "レイヤーセットも対象にする(&L)"
		,_Delimiter			: "レイヤーセット間区切り記号:"
		,_extract			: "選択したレイヤーを抽出(&E)"
	}
	//> 保存形式
	,SaveFormat	: {
		 _Path			: "書き出し先フォルダ:"
		,_Prefix		: "ファイル名先頭:"
		,_Suffix		: "ファイル名末尾:"
		,FileType		: [PNG_EXTENSION, BMP_EXTENSION, JPG_EXTENSION, GIF_EXTENSION, PSD_EXTENSION]
		,Transparent	: "レイヤーの透明部分を透過処理する(&T)"
		,ConfirmEnabled	: "サブフォルダ作成時に毎回確認する(&C)"
		,_saveBrowser	: "レイヤー画像を書き出す先のフォルダを選択してください。"
		,_layerName		: "*"
		,_FileType		: "ファイルタイプ:"
		,_sameName		: "PSDドキュメントと同名のサブフォルダ"
	}
	//> 切り抜き形式
	,CropInBounds	: {
		 Type				: ["切り抜かない(&D)", "親レイヤーセットのレイヤーマスク範囲に合わせて切り抜く(&P)", "各レイヤーのピクセル存在範囲に合わせて切り抜く(&E)"]
		,LeftProtected		: "左の空白を保護(&A)"
		,TopProtected		: "上の空白を保護(&W)"
		,RightProtected		: "右の空白を保護(&D)"
		,BottomProtected	: "下の空白を保護(&S)"
		,OverPixelsProtected: "表示領域の外側のピクセルも含める(&X)"
	}
	//> リサイズ形式
	,Resize	: {
		 Enabled			: "画像を拡大・縮小する(&E)"
		,AfterCrop			: "切り抜きがあるとき切り抜きの後で拡大・縮小(&C)"
		,Mode				: ["一律に変更", "サイズが値以上なら変更", "サイズが値以下なら変更"]
		,_Width				: "　　　横幅:"
		,_Height			: "　　　縦幅:"
		,ResampleType		: TEXT_RESAMPLE_LIST
		,_Resample			: "再サンプル:"
	}
	//> 表示形式
	,FixedLayer	: {
		 Enabled			: "特定のレイヤーを常に表示する(&E)"
		,_Prefix			: "対象レイヤーの先頭文字:"
		,Background			: "背景レイヤーも対象に含める(&B)"
		,SingleSave			: "対象レイヤーを単独でも書き出す(&S)"
	}
	//> バックアップ
	,Backup		: {
		 Type				: ["上書き確認を行う(&C)", "すべて上書き(&A)", "上書きしない(&N)", "古いファイルを自動的にバックアップフォルダへ移動する(&M)"]
		,_suffixAdded		: "末尾に書き出しカウントを付ける(&E)"
		,_Path				: "バックアップフォルダ:"
		,_reset				: "書き出し先に合わせる(&R)"
	}

	//> Jpeg形式
	,JpegFormat	: {
		 Quality		: [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12]
		,Format			: ["ベースライン（標準）(&S)", "ベースライン（最適化）(&O)", "プログレッシブ(&P)"]
		,Scans			: [3, 4, 5]
		,_Quality		: "画質:"
		,_qualityLow	: "低"
		,_qualityHigh	: "高"
		,_Format		: "形式オプション"
		,_Scans			: "スキャン:"
	}
	//> カウンタ
	,Counter	: {
		 Figure				: [1, 2, 3, 4, 5, 6, 7, 8]
		,_Value				: "現在の書き出しカウント: "
		,_Figure			: "最小桁数:"
	}
	//> 書き出しログ
	,Log	: {
		 Type				: ["出力しない", "書き出し先と同じフォルダ", "書き出し元と同じフォルダ"]
		,Encoding			: ["Shift-JIS", "UTF-8", "UTF-16LE", "UTF-16BE"]
		,Mode				: ["追加保存", "上書き保存", "個別保存"]
		,_Type				: "レイヤー情報ファイル出力先:"
		,_FileType			: "ファイル拡張子:"
		,_Encoding			: "文字コード:"
		,_Format			: "書き出しログ書式:"
		,_formatHeader		: "先頭:"
		,_formatTop			: "開始:"
		,_formatItem		: "個別:"
		,_formatBottom		: "終了:"
		,_formatFoot		: "末尾:"
		,_formatDefaultButton	: "標準"
		,_formatHTMLButton	: "HTML用"
		,_formatCSVButton	: "CSV用"
		,_formatHelpButton	: "書式ヘルプ(&H)"
	}
};

//> ヘルプチップ
_configData.helpData	= {
	 Resize	: {
		 AfterCrop		: "絶対値による幅指定と座標情報に影響します。"
		,"Width,Height"	: "\"%\"で相対指定・\"px\"でピクセル絶対指定"
	}
	,_metaTitle		: "親フォルダ名"
};

//> 設定データ標準値
_configData.defaultData	= {
	 ScriptTitle	: SCRIPT_TITLE
	,ScriptVersion	: VERSION
	//> レイヤーセット
	,TargetLayer	: {
		 Included			: true
		,VisibleOnly		: true
		,Delimiter			: "_"
	}
	//> 保存形式
	,SaveFormat	: {
		 Path				: "./"
		,Prefix				: ""
		,Suffix				: ""
		,FileType			: 0	//png
		,Transparent		: true
		,ConfirmEnabled		: true
	}
	//> 切り抜き形式
	,CropInBounds	: {
		 Type				: INDEX_NOT_CROP
		,LeftProtected		: false
		,TopProtected		: false
		,RightProtected		: false
		,BottomProtected	: false
		,OverPixelsProtected: false
	}
	//> リサイズ形式
	,Resize	: {
		 Enabled			: false
		,AfterCrop			: false
		,Mode				: 0
		,Width				: "100%"
		,Height				: "100%"
		,ResampleType		: INDEX_RESAMPLE_BICUBIC
	}
	//> 表示形式
	,FixedLayer	: {
		 Enabled			: false
		,Prefix				: "&"
		,Background			: false
		,SingleSave			: false
	}
	//> バックアップ
	,Backup		: {
		 Type				: INDEX_BACKUP_CONFIRM
		,Path				: "./" + BACKUP_FOLDER_PREFIX + NAME_TAG + BACKUP_FOLDER_SUFFIX
	}
	//> Jpeg形式
	,JpegFormat	: {
		 Quality			: 8
		,Format				: 0
		,Scans				: 0
	}
	//> カウンタ
	,Counter	: {
		 Value				: 1
		,Figure				: 1
	}
	//> 書き出しログ
	,Log	: {
		 Type				: INDEX_LOG_DONOT_SAVE
		,Encoding			: 0
		,Mode				: 0
		,FileType			: "txt"
		,HeadForm			: DEFAULT_LOG_HEAD
		,TopForm			: DEFAULT_LOG_TOP
		,ItemForm			: DEFAULT_LOG_ITEM
		,BottomForm			: DEFAULT_LOG_BOTTOM
		,FootForm			: DEFAULT_LOG_FOOT
	}
	,currentStack			: INDEX_SAVE_FORMAT	//※ConfigDialogによって自動付与される現在表示パネルスタック番号
};

//> 設定データ最小値
_configData.minData	= {
	 Counter	: {
		 Value				: 1
	}
};

//> 設定データ最大値
_configData.maxData	= {
	 Counter	: {
		 Value				: COUNT_MAX_VALUE
	}
};

//> 設定データリスト値
_configData.listData	= {
	 JpegFormat	: {
		 Format			: [FormatOptions.STANDARDBASELINE, FormatOptions.OPTIMIZEDBASELINE, FormatOptions.PROGRESSIVE]
	}
	,Resize	: {
		 ResampleType	: RESAMPLE_LIST
		,Mode			: ["", "max", "min"]
	}
	,Log	: {
		 Mode	: ["top", "", ""]
	}
};

//> ダイアログ横幅
_configData.widthData	= {
	 "*"	: 600	//ウィンドウサイズ
	,_frame	: 380
	,TargetLayer	: {
		 "_extract,_filter,_progress,_progressInfo"	: 190
		,Delimiter	: 24
		,_names	: 200
	}
	,SaveFormat	: {
		 Path	: 330
		,"Prefix,Suffix"	: 100
		,FileType	: 80
	}
	,CropInBounds	: {
		 _hr	: 240
	}
	,Resize	: {
		 "Width,Height"	: 80
	}
	,FixedLayer	: {
		 Prefix		: 80
	}
	,Backup		: {
		 Path		: 300
	}
	,JpegFormat	: {
		 "Quality,Scans"	: 40
		,Quality_	: 120
	}
	,Counter	: {
		 Value	: 100
		,Figure	: 60
	}
	,Log	: {
		 FileType	: 60
		,"HeadForm,TopForm,ItemForm,BottomForm,FootForm"	: 320
	}
	,currentStack	: 140
};

//> ダイアログ縦幅
_configData.heightData	= {
	 "*"	: 320	//ウィンドウサイズ
	,_frame	: 260
	,TargetLayer	: {
		 _names	: 200
	}
	,currentStack	: 210
};

//--> 本体実行
main();


///-------------------------------------------------------------
///	メインフロー関数
//--------------------------------------------------------------

///{} 本体
function main() {

	//--? 起動時チェック
	try{
		ScriptUtil.inspectDocumentExists();
		ScriptUtil.inspectPhotoshopVersion();
		ScriptUtil.inspectDocumentFormat();
	}catch(e){
		_resonance.showError(e);
		return;
	}

	//--> 座標計測用に単位を一時的にPixelにする
	var originalRulerUnits	= preferences.rulerUnits;
	preferences.rulerUnits	= Units.PIXELS;

	try{

		mainFlow();

	}catch(e){
		_resonance.showError(e);
	}

	//--> 単位をオリジナルのものに戻す
	preferences.rulerUnits	= originalRulerUnits;

	//--? エラーによって書き出し用のテンポラリドキュメントが残ったままなら無保存終了
	//※ [Esc]キーで中断された場合はフォロー不可能
	if(_config.global.temp_doc){
		_config.global.temp_doc.close(SaveOptions.DONOTSAVECHANGES);
	}

};


///{} メインフロー
function mainFlow() {

	//--> 設定データを読み込みダイアログに適用
	loadConfig();

	//> 現在選択レイヤーを記憶
	var current_layer	= activeDocument.activeLayer;

	//--? 設定ダイアログを表示してキャンセルされなければ一斉出力処理
	if(_config.show()){
		exportLayers();
	}

	//> 起動時選択レイヤーを復元
	activeDocument.activeLayer	= current_layer;

};


///-------------------------------------------------------------
///	ダイアログ設定関数
//--------------------------------------------------------------

///{} XMLファイルから設定を読み込みダイアログに適用
function loadConfig() {

	//--> XMLデータをオブジェクトに変換してダイアログと関連付けるクラスを生成
	_config	= new ConfigDialog(_configData);
	ScriptUtil.tries(_resonance.windowTitle, _config.connectXMLON, _config, [
		 _resonance.configFilePath
		,SCRIPT_TITLE
	]);

	//--? 初期表示スタックが対象レイヤーパネルなら保存形式パネルに変更
	if(_config.data.currentStack == INDEX_TARGET_LAYERS){
		_config.data.currentStack	= INDEX_SAVE_FORMAT;
	}

	//> ウィンドウタイトル
	_config.title	= _resonance.windowTitle;

  ///{} ダイアログのレイアウトと設定データの対応を準備する
  _config.prepare	= function(){

	var data			= this.data;
	var global			= this.global;
	var adjustPath		= FileUtil.adjustPath;

	//--? ドキュメント保存フォルダのパスを取得
	global.documentPath	= _resonance.documentParentPath;

	//--> 最上階層のレイヤーセットを取得
	var rootLayerSets		= [""];
	var rootLayerSetNames	= ["...（レイヤーセットフィルタ）"];
	var rootLayers			= activeDocument.layers;
	var layer;
	var len	= rootLayers.length;
	for(var i = 0; i < len; i++){
		layer	= rootLayers[i];
		if(layer.typename == "LayerSet" && layer.name.indexOf(EXCEPT_PREFIX) != 0){
			rootLayerSets.push(layer);
			rootLayerSetNames.push(layer.name);
		}
	}

	/// レイアウト

	const RADIO_ITEM_PREFIX	= ConfigDialog.RADIO_ITEM_PREFIX;

	const NARROW_SPACE	= ConfigDialog.NARROW_SPACE;
	const BROAD_SPACE	= ConfigDialog.BROAD_SPACE;

	const column_opt	= this.setOptions({orientation:"column"});
	const stack_opt		= this.setOptions({orientation:"column", alignChildren:"left"});
	const indent_opt	= this.setOptions({orientation:"column", alignChildren:"left", margins:[BROAD_SPACE, undefined, undefined, undefined]});
	const vertical_opt	= this.setOptions({orientation:"column", alignChildren:"left", spacing:NARROW_SPACE});
	const path_opt		= this.setOptions({orientation:"column", alignChildren:"right", spacing:NARROW_SPACE});
	const left_opt		= this.setOptions({orientation:"column", alignChildren:"right"});
	const right_opt		= this.setOptions({orientation:"column", alignChildren:"left"});
	const alignRight_opt	= this.setOptions({alignment:"right"});

	//--> メインウィンドウ生成
	this.create({orientation:"row", alignChildren:"top"});

	//--> メインパネル切り換えメニュー
	this.addGroup("_stackMenu");

	//--> メインパネル
	this.addGroup("_stack", column_opt);
	this.addPanel("_stack/_frame", {orientation:"stack", alignChildren:"left"});

	/// 対象レイヤー
	this.addGroup("_stack/_frame/TargetLayer");
		this.addGroup("_stack/_frame/TargetLayer/_layers", stack_opt);
			//--> 設定
			this.addCheckBox("VisibleOnly");
			this.addCheckBox("Included");
			this.addGroup("_stack/_frame/TargetLayer/_layers/_nameDelimiter");
				this.addText("_Delimiter");
				this.addEditText("Delimiter");
			this.ascend();
			//--> フィルタ
			var filter_btn	= this.addButton("_extract", undefined, "onClickFiltering");
			var filter_ddl	= this.addDropDownList("_filter", undefined, "onChangeFilter", rootLayerSetNames, 0);
			filter_btn.enabled	= false;
			this.addSpace();
				//--> プログレスバー
				var progress_grp	= this.addGroup("_stack/_frame/TargetLayer/_layers/_progress", column_opt, undefined, true);
					var layer_stx	= this.addText("_progressInfo");
					var target_prg	= this.addProgressBar("_progress");
					target_prg.info_item	= layer_stx;
		//--> 対象レイヤー一覧表示リストボックス
		var target_grp	= this.addGroup("_stack/_frame/TargetLayer/_target", {orientation:"column", height:200}, undefined, true);
			var target_lbx	= this.addListBox("_names", undefined, undefined, undefined, undefined, true);

	/// ファイル形式
	this.addGroup("_stack/_frame/SaveFormat", stack_opt);
		//--> 保存先フォルダ
		this.addText("_Path");
		this.addGroup("_stack/_frame/SaveFormat/_savePath", column_opt);
			this.addGroup("_stack/_frame/SaveFormat/_savePath/_savePath");
				this.addImage("DestinationFolderIcon");
				this.addGroup("_stack/_frame/SaveFormat/_savePath/_savePath/_savePath", path_opt);
					var savePath_etx	= this.addEditText("Path", {helpTip:adjustPath(data.SaveFormat.Path, global.documentPath)});
					this.addGroup("_stack/_frame/SaveFormat/_savePath/_savePath/_savePath/_button", alignRight_opt);
						this.addButton("_sameName", undefined, "onClickSaveSameName");
						this.addButton("_browser", undefined, "onClickSaveBrowser");
		this.addGroup("_stack/_frame/SaveFormat/_fix", {alignment:"center"});
			//--> ファイル名接頭辞
			this.addGroup("_stack/_frame/SaveFormat/_fix/_savePrefix", vertical_opt);
				this.addText("_Prefix");
				this.addEditText("Prefix");
				this.ascend();
			this.addMultiText(NEW_LINE + this.infoData.SaveFormat._layerName);
			//--> ファイル名接尾辞
			this.addGroup("_stack/_frame/SaveFormat/_fix/_saveSuffix", vertical_opt);
				this.addText("_Suffix");
				this.addEditText("Suffix");
				this.ascend();
			//--> ファイルタイプ（拡張子）
			this.addGroup("_stack/_frame/SaveFormat/_fix/_fileType", vertical_opt);
				this.addText("_FileType");
				this.addDropDownList("FileType");
				this.ascend();
			this.ascend();
		this.addSpace();
		//--> サブフォルダ作成時の確認
		this.addCheckBox("ConfirmEnabled");
		//--> 透過処理の有無
		this.addCheckBox("Transparent");

	/// 切り抜き形式
	this.addGroup("_stack/_frame/CropInBounds", stack_opt);
		//--> 切り抜きの有無
		this.addGroup("_stack/_frame/CropInBounds/Type", stack_opt);
			this.addRadioButtonItem();
			var topLayer	= activeDocument.layers[0];
			this.addRadioButtonItem(undefined, {helpTip:'"' + topLayer.name + '" (' + topLayer.typename + ')'});
			this.addRadioButtonItem();
		//--> 四隅の保護
		var protection_pnl	= this.addPanel("_stack/_frame/CropInBounds/_protection", column_opt, undefined, false, "sunken");
		protection_pnl.enabled	= (data.CropInBounds.Type != INDEX_NOT_CROP);
			this.addCheckBox("TopProtected");
			this.addGroup("_stack/_frame/CropInBounds/_protection/_lr");
				this.addCheckBox("LeftProtected");
				this.addCheckBox("RightProtected");
				this.ascend();
			this.addCheckBox("BottomProtected");
			this.addHorizon("_hr");
			//--> 画面外の保護
			this.addCheckBox("OverPixelsProtected");

	/// 拡大・縮小
	this.addGroup("_stack/_frame/Resize", stack_opt);
		this.addCheckBox("Enabled");
		var resize_pnl	= this.addPanel("_stack/_frame/Resize/_resize", stack_opt, undefined, false, "sunken");
		resize_pnl.enabled	= data.Resize.Enabled;
		this.addCheckBox("AfterCrop");
		this.addDropDownList("Mode");
		this.addGroup("_stack/_frame/Resize/_resize/_format", {orientation:"row"});
			this.addGroup("_stack/_frame/Resize/_resize/_format/_subject", left_opt);
				this.addText("_Width");
				this.addText("_Height");
				this.addText("_Resample");
			this.addGroup("_stack/_frame/Resize/_resize/_format/_resizeEdit", right_opt);
				this.addEditText("Width");
				this.addEditText("Height");
				this.addDropDownList("ResampleType");

	/// 表示形式
	this.addGroup("_stack/_frame/FixedLayer", stack_opt);
		var fcb = this.addCheckBox("Enabled");
		var visible_pnl	= this.addPanel("_stack/_frame/FixedLayer/_format", stack_opt, undefined, false, "sunken");
		visible_pnl.enabled	= data.FixedLayer.Enabled;
			this.addGroup("_stack/_frame/FixedLayer/_format/_fixedPrefix");
				this.addText("_Prefix");
				this.addEditText("Prefix");
				this.ascend();
			this.addCheckBox("Background");
			this.addCheckBox("SingleSave");

	/// 更新管理
	this.addGroup("_stack/_frame/Backup", stack_opt);
		this.addGroup("_stack/_frame/Backup/Type", stack_opt);
			this.addRadioButtonItem();
			this.addRadioButtonItem();
			this.addRadioButtonItem();
			this.addRadioButtonItem();
			this.ascend();
		var backup_pnl	= this.addPanel("_stack/_frame/Backup/_backup", stack_opt, undefined, false, "sunken");
		backup_pnl.enabled	= (data.Backup.Type == INDEX_BACKUP_FOLDER);
			this.addText("_Path");
				this.addGroup("_stack/_frame/Backup/_backup/_backupPath");
					this.addImage("DestinationFolderIcon");
					this.addGroup("_stack/_frame/Backup/_backup/_backupPath/_backupPath", path_opt);
						var backupPath_etx	= this.addEditText("Path", {helpTip:adjustPath(data.Backup.Path, global.documentPath)});
					this.addGroup("_stack/_frame/Backup/_backup/_backupPath/_backupPath/_button");
						this.addButton("_reset", alignRight_opt, "onClickBackupReset");
						this.addButton("_browser", alignRight_opt, "onClickBackupBrowser");
						this.ascend();
					this.ascend();
				this.ascend();
			this.addButton("_suffixAdded", alignRight_opt, "onClickBackupSuffix");

	/// Jpegオプション
	this.addGroup("_stack/_frame/JpegFormat", stack_opt);
		//--> 画質
		this.addGroup("_stack/_frame/JpegFormat/_jpegQuality");
			this.addText("_Quality");
			var jpegQuality_ddl	= this.addDropDownList("Quality");
			this.addText("_qualityLow");
			var jpegQuality_sld	= this.addSlider("Quality_");
			this.addText("_qualityHigh");
		//--> 形式
		this.addPanel("_stack/_frame/JpegFormat/_Format", stack_opt);
			this.addGroup("_stack/_frame/JpegFormat/_Format/Format", stack_opt);
				this.addRadioButtonItem();
				this.addRadioButtonItem();
				this.addRadioButtonItem();
			//--> プログレッシブ保存時のスキャン値
			var scans_grp	= this.addGroup("_stack/_frame/JpegFormat/_Format/_scans");
			scans_grp.enabled	= (this.getListValue("JpegFormat.Format") == FormatOptions.PROGRESSIVE);
				this.addText("_Scans");
				this.addDropDownList("Scans");

	/// カウンタ設定
	this.addGroup("_stack/_frame/Counter");
		this.addGroup("_stack/_frame/Counter/_subject", left_opt);
			this.addText("_Value");
			this.addSpace();
			this.addText("_Figure");
		this.addGroup("_stack/_frame/Counter/_counterEdit", right_opt);
			var counter_etx	= this.addEditText("Value");
			this.addSpace();
			var counter_ddl	= this.addDropDownList("Figure");

	/// 書き出しログ
	this.addGroup("_stack/_frame/Log", stack_opt);
		this.addGroup("_stack/_frame/Log/_logType");
			this.addText("_Type");
			this.addDropDownList("Type");
		var logConfig_grp	= this.addGroup("_stack/_frame/Log/_select", alignRight_opt);
			this.addDropDownList("Mode");
			this.addText("_FileType");
			var logExtens_etx	= this.addEditText("FileType");
			this.addText("_Encoding");
			this.addDropDownList("Encoding");
		var logForm_pnl	= this.addPanel("_stack/_frame/Log/_form", {orientation:"column", alignChildren:"right", spacing:NARROW_SPACE}, undefined, false, "sunken");
			this.addGroup("_stack/_frame/Log/_form/_formHeader");
				this.addText("_formatHeader");
				var logHead_etx	= this.addEditText("HeadForm");
			this.addGroup("_stack/_frame/Log/_form/_formTop");
				this.addText("_formatTop");
				var logTop_etx	= this.addEditText("TopForm");
			this.addGroup("_stack/_frame/Log/_form/_formItem");
				this.addText("_formatItem");
				var logItem_etx	= this.addEditText("ItemForm");
			this.addGroup("_stack/_frame/Log/_form/_formBottom");
				this.addText("_formatBottom");
				var logBottom_etx	= this.addEditText("BottomForm");
			this.addGroup("_stack/_frame/Log/_form/_formFoot");
				this.addText("_formatFoot");
				var logFoot_etx	= this.addEditText("FootForm");
		this.addGroup("_stack/_frame/Log/_form/_button", {alignChildren:"right"});
			this.addButton("_formatDefaultButton", undefined, "onClickLogDefault");
			this.addButton("_formatHTMLButton", undefined, "onClickLogHTML");
			this.addButton("_formatCSVButton", undefined, "onClickLogCSV");
			this.addButton("_formatHelpButton", undefined, "onClickLogHelp");

	/// その他
	this.addGroup("_stack/_frame/Options", {orientation:"column", alignChildren:"left", spacing:BROAD_SPACE});
		this.addConfirmCheckBox();
		this.addMetaDataLongButton();
		this.addResetLongButton();

	//--> スタックパネル切り換えメニュー
	var stack_grp	= this.addStackChanger("_stackMenu/");

	//--> 基本ボタン
	this.addGroup("_stack/_button", alignRight_opt);
		this.addButton("_get", undefined, "onClickTarget", BUTTON_GET_TARGET);
		var button_grp	= this.addMainButton("_stack/_button/_button", alignRight_opt, true);
		button_grp.ok_btn.enabled	= false;

	/// イベントハンドラ

	var eventListener	= {};

	//e{} 対象レイヤー取得ボタンイベント
	eventListener.onClickTarget	= function(conf, item){
		if(data.currentStack == INDEX_TARGET_LAYERS){
			renewTargetLayer();
		}else{
			stack_grp.changeStack(INDEX_TARGET_LAYERS);
		}
	};

	//e{} 対象読み込み進捗イベント
	eventListener.onStartProgress	= function(conf, item){
		button_grp.ok_btn.enabled	= false;
	};
	eventListener.onCompleteProgress	= function(conf, item){
		button_grp.ok_btn.enabled	 = true;
		button_grp.ok_btn.text	= "OK";
	};

	//e{} レイヤーセットフィルタ変更イベント
	eventListener.onChangeFilter	= function(conf, item){
		if(conf.showed){
			renewTargetLayer();
		}
	};

	//e{} 選択レイヤーフィルタリングイベント
	eventListener.onClickFiltering	= function(conf, item){
		var filteringLayers	= [];
		var targetLayers	= _config.global.targetLayers;
		var selection		= target_lbx.selection;
		var len				= selection.length;
		for(var i = 0; i < len; i++){
			filteringLayers[i]	= targetLayers[selection[i].index];
		}
		renewTargetLayer(filteringLayers);
		item.enabled	= false;
	};

	//e{} 対象レイヤーリストボックス選択イベント
	target_lbx.onChange	= function(){
		filter_btn.enabled	= (this.selection != undefined);
	}

	//e{} OKボタンイベント
	button_grp.ok_btn.onClick	= function(){
		if(_config.confirmAs(getExportFormat() + CONFIRM_EXPORT, _resonance.windowTitle)){
			_config.close(true);
		}
	};

	function setSavePath(path){
		_config.data.SaveFormat.Path	= savePath_etx.text	= path;
		savePath_etx.helpTip			= adjustPath(path, _config.global.documentPath);
	};
	function setBackupPath(path){
		_config.data.Backup.Path	= backupPath_etx.text	= path;
		backupPath_etx.helpTip		= adjustPath(path, _config.global.documentPath);
	};
	function setLogFileType(extens){
		_config.data.Log.FileType	= logExtens_etx.text	= extens;
	};

	//e{} 同名サブフォルダ挿入ボタンイベント
	eventListener.onClickSaveSameName	= function(conf, item){
		setSavePath("./" + NAME_TAG);
	};
	//e{} 書き出し先フォルダ参照ボタンイベント
	eventListener.onClickSaveBrowser	= function(conf, item){
		var basePath	= adjustPath(conf.data.SaveFormat.Path, conf.global.documentPath);
		if(!new Folder(basePath).exists){
			basePath	= conf.global.documentPath;
		}
		var result_folder = Folder.selectDialog(conf.infoData.SaveFormat._saveBrowser, basePath);
		if(result_folder){
			setSavePath(result_folder.fsName);
		}
	};
	//e{} バックアップフォルダ生成先リセットボタンイベント
	eventListener.onClickBackupReset	= function(conf, item){
		setBackupPath(
			(conf.data.SaveFormat.Path + "/" + BACKUP_FOLDER_PREFIX + NAME_TAG + BACKUP_FOLDER_SUFFIX).replace(/\/+/g, "/")
		);
	};
	//e{} バックアップフォルダ生成先フォルダ参照ボタンイベント
	eventListener.onClickBackupBrowser	= function(conf, item){
		var basePath	= adjustPath(conf.data.Backup.Path, conf.global.documentPath);
		var result_folder = Folder.selectDialog(conf.infoData.Backup._Path, basePath);
		if(result_folder){
			setBackupPath(result_folder.fsName);
		}
	};
	//e{} バックアップフォルダ名末尾書き出しカウント付与ボタンイベント
	var countSuffix_reg	= new RegExp("(" + COUNT_TAG + "|" + COUNT2_TAG + ")$");
	eventListener.onClickBackupSuffix	= function(conf, item){
		if(!countSuffix_reg.test(backupPath_etx.text)){
			setBackupPath(backupPath_etx.text + COUNT_TAG);
		}
	}

	//e{} 書き出しログボタンイベント
	function onClickLog(head, top, body, bottom, foot, extens, type){
		if(_config.confirmAs(
			 CONFIRM_LOG_FORM_PREFIX + type + CONFIRM_LOG_FORM_SUFFIX
			,TITLE_LOG_FORM
		)){
			_config.data.Log.HeadForm	= logHead_etx.text	= head.replace(/[\t\r\n]/g, "");
			_config.data.Log.TopForm	= logTop_etx.text	= top.replace(/[\t\r\n]/g, "");
			_config.data.Log.ItemForm	= logItem_etx.text	= body.replace(/[\t\r\n]/g, "");
			_config.data.Log.BottomForm	= logBottom_etx.text= bottom.replace(/[\t\r\n]/g, "");
			_config.data.Log.FootForm	= logFoot_etx.text	= foot.replace(/[\t\r\n]/g, "");
			setLogFileType(extens);
		}else{
			_config.cancelApplyButton();
		}
	}
	//e{} 書き出しログ標準ボタンイベント
	eventListener.onClickLogDefault	= function(conf, item){
		onClickLog(
			 DEFAULT_LOG_HEAD
			,DEFAULT_LOG_TOP
			,DEFAULT_LOG_ITEM
			,DEFAULT_LOG_BOTTOM
			,DEFAULT_LOG_FOOT
			,conf.defaultData.Log.FileType
			,conf.infoData.Log._formatDefaultButton
		);
	};

	//e{} 書き出しログHTMLボタンイベント
	eventListener.onClickLogHTML	= function(conf, item){
		onClickLog(
			 HTML_LOG_HEAD
			,HTML_LOG_TOP
			,HTML_LOG_ITEM
			,HTML_LOG_BOTTOM
			,HTML_LOG_FOOT
			,"html"
			,conf.infoData.Log._formatHTMLButton
		);
	};
	//e{} 書き出しログCSVボタンイベント
	eventListener.onClickLogCSV	= function(conf, item){
		onClickLog(
			 CSV_LOG_HEAD
			,""
			,CSV_LOG_BODY
			,""
			,""
			,"csv"
			,conf.infoData.Log._formatCSVButton
		);
	};
	//e{} 書き出しログボタンイベント
	eventListener.onClickLogHelp	= function(conf, item){
		showLogHelp();
	};

	//{} 書き出し対象レイヤー更新
	function renewTargetLayer(layers){
		_config.untouchable();
		var layerSet;
		if(filter_ddl.selection.index != 0){
			layerSet	= rootLayerSets[filter_ddl.selection.index];
		}
		_config.dispatchEvent("onStartProgress", target_prg);
		//--> 対象レイヤーを総取得
		_config.global.layerNames	= [];
		if(layers){
			_config.global.targetLayers	= layers;
		}else{
			try{
				_config.global.targetLayers	= getTargetLayers(
					 layerSet ? layerSet.layers : activeDocument.layers
					,data.TargetLayer.VisibleOnly
					,data.TargetLayer.Included
					,target_prg
				);
			}catch(e){
			}
		}
		//--? 対象がなければキャンセル
		if(!_config.global.targetLayers.length){
			target_lbx.removeAll();
			_config.touchable();
			return;
		}
		//--> 保存対象レイヤーの親レイヤーセット名も反映したフルネームリストを取得
		var layerNames	= _config.global.layerNames	= getLayerNames(_config.global.targetLayers, target_prg);
		target_prg.onCompleteProgress();
		//{--} リストボックス更新
		target_lbx.removeAll();
		var len	= _config.global.targetLayers.length;
		for(var i = 0; i < len; i++){
			target_lbx.add("item", layerNames[i]);
		}
		_config.touchable();
	};

	//{$} リサイズ入力後補正
	function reviseResizeValue(value, defaultValue){
		if(value.indexOf("*") != -1){
			return "*";
		}
		var n	= parseFloat(value);
		if(isNaN(n)){
			return defaultValue;
		}else{
			return (value.indexOf("p") != -1) ? parseInt(n) + "px" : n + "%";
		}
	};

	///e{} 汎用設定データ変更イベント
	eventListener.onChangeValue	= function(conf, item){
		switch(item.parent.name){
			case "_layers":	//in TargetLayer
				renewTargetLayer();
				break;
			case "_nameDelimiter":	//in TargetLayer
				item.text	= FileUtil.replaceDonotUseChar(item.text, FILE_NAME_REPLACE_CHAR);
				conf.data.TargetLayer.Delimiter	= item.text;
				renewTargetLayer();
				break;
			case "_savePath":	//in SaveFormat
				setSavePath(item.text);
				break;
			case "_savePrefix":	//in SaveFormat
			case "_savePrefix":	//in SaveFormat
				item.text	= item.text;//FileUtil.replaceDonotUseChar(item.text, FILE_NAME_REPLACE_CHAR);
				if(item.name == "Prefix"){
					conf.data.SaveFormat.Prefix	= item.text;
				}else{
					conf.data.SaveFormat.Suffix	= item.text;
				}
				break;
			case "Type":	//in CropInBounds | Log | Backup
				switch(item.parent.parent.name){
					case "CropInBounds":
//※【未完】use index
						protection_pnl.enabled	= (item.name != RADIO_ITEM_PREFIX + INDEX_NOT_CROP);
						break;
					case "Backup":
						backup_pnl.enabled	= (item.name == RADIO_ITEM_PREFIX + INDEX_BACKUP_FOLDER);
						break;
				}
				break;
			case "_logType":
				logConfig_grp.enabled	= logForm_pnl.enabled	= (conf.data.Log.Type != INDEX_LOG_DONOT_SAVE);
				break;
			case "Resize":
				if(item.name == "Enabled"){
					resize_pnl.enabled	= item.value;
				}
				break;
			case "_resizeEdit":
				switch(item.name){
					case "Width":
						conf.data.Resize.Width	= item.text	= reviseResizeValue(item.text, conf.defaultData.Resize.Width);
						break;
					case "Height":
						conf.data.Resize.Height	= item.text	= reviseResizeValue(item.text, conf.defaultData.Resize.Height);
						break;
				}
				break;
			case "FixedLayer":
				if(item.name == "Enabled"){
					visible_pnl.enabled	= item.value;
				}
				break;
			case "_backupPath":	//in Backup
				setBackupPath(item.text);
				break;
			case "_jpegQuality":	//in JpegFormat
				switch(item.name){
					case "Quality":
						jpegQuality_sld.value	= item.selection.index;
						break;
					case "Quality_":
						jpegQuality_ddl.selection	= item.value;
						break;
				}
				break;
			case "Format":	//in JpegFormat
				//(!) プログレッシブ形式の場合のみスキャン値を有効にする
				scans_grp.enabled	= (conf.getListValue("JpegFormat.Format") == FormatOptions.PROGRESSIVE);
				break;
			case "_counterEdit":
				switch(item.name){
					case "Value":
						var s	= item.text;
						var n	= parseInt(item.text);
						if(isNaN(n)){
							n	= 0;
						}else if(n > COUNT_MAX_VALUE){
							n	= COUNT_MAX_VALUE;
						}
						item.text	= String(n);
						conf.data.Counter.Value	= n;
						break;
				}
				counter_ddl.helpTip	= counter_etx.helpTip	= COUNT_PREFIX +
					StringUtil.supply0To(conf.data.Counter.Value, conf.getListValue("Counter.Figure"));
				break;
			case "_logFileType":	//in Log
				item.text	= item.text;//FileUtil.replaceDonotUseChar(item.text, FILE_NAME_REPLACE_CHAR);
				break;
			default:
				break;
		}
	};

	///e{} メタデータ取得ボタンイベント
	eventListener.onClickMetaData	= function(conf, item){
		_resonance.setConfigMetaData(conf.helpData._metaTitle, _resonance.documentParentName);
	};

	//e{} ダイアログ終了イベント
	eventListener.onClose	= function(conf, result){
		if(result){
			//--> 書き出し回数加算
			countUp();
			conf.save();
		}
	};

	//e{} エラー表示イベント
	eventListener.onError	= function(conf, item, e){
		alert(e + "\t" + dump(item), Resonance.title.ERROR, true);
	};

	//--> イベントリスナーを登録
	this.setListener(eventListener);

  };

};


///-------------------------------------------------------------
///	詳細処理関数
//--------------------------------------------------------------

///r{a} レイヤーセット内のレイヤーも再帰的にチェックして上から順に有効な全レイヤーの一覧を取得
function getTargetLayers(layers, visibleOnly, layerSetIncluded, eventHandler, list, parentProgress, parentLength) {

	//--? 未指定なら初期値を適用
	if(list == undefined)			list	= [];
	if(parentProgress == undefined)	parentProgress	= 0;
	if(parentLength == undefined)	parentLength	= 1;

	//{--} 表示中の全レイヤーを上から順にリストアップ
	var groupSign_reg	= new RegExp(REG_GROUP_DELIMITER, "g");
	var group_reg		= new RegExp(REG_GROUP_NAME, "g");
	var groups;
	var groupNames;
	const T_PREFIX		= THROUGH_PREFIX;
	const G_DELIMITER	= GROUP_DELIMITER;
	var name;
	var groupLength;
	var emptyExist;
	var layer;
	var len	= layers.length;
	var max			= len * parentLength;
	var progress	= parentProgress;
	var j;
	for(var i = 0; i < len; i++){
		if(!_config.isProgressing){
			throw new ConfigDialog.CancelProgressError();
		}
		layer	= layers[i];
		if(visibleOnly && !layer.visible){
			continue;
		}
		name	= layer.name;
		if(name.indexOf(EXCEPT_PREFIX) == 0){
			continue;
		}
		if(
			layer.typename == "LayerSet"
			&&
			(
				//(!) レイヤーセットを含める設定でも先頭が例外的スルー記号であれば含めない
				(layerSetIncluded && name.indexOf(T_PREFIX) == 0)
				||
				//(!) レイヤーセットを含めない設定でグループが関連付けられていない場合
				(!layerSetIncluded && name.indexOf(G_DELIMITER) == - 1)
			)
		){
			//--> 配下のレイヤーを再帰的に登録
			list = getTargetLayers(layer.layers, visibleOnly, layerSetIncluded, eventHandler, list, progress, len * parentLength);
		}else{
			//(!) アートレイヤーまたはレイヤーセットをリストに登録
			groups	= name.match(groupSign_reg, "g");
			if(groups){
				//(!) グループが関連付けられている場合その分だけ多重登録
				groupLength	= groups.length;
				groupNames	= name.match(group_reg, "g");
				groupNames.shift();	//※最初は基本名なので除外
				emptyExist	= false;
				for(j = 0; j < groupLength; j++){
					if(groupNames[j]){
						list.push(layer);
					}else{
						if(!emptyExist){
							list.push(layer);
						}
						emptyExist	= true;
					}
				}
			}else{
				list.push(layer);
			}
		}
		//--> 進捗
		if(eventHandler){
			progress	= parentProgress + Math.round((i + 1) / max * 50);	//50…getLayerNamesと合わせて100%
			eventHandler.info	= layer.name;
			eventHandler.onProgress(progress);
		}
	}

	return list;

};


///{a} レイヤーセットの階層に応じた保存名の一覧を取得（空白は自動削除）（"|"以降の文字も自動削除）
function getLayerNames(layersList, eventHandler) {

	var targetLayerNames	= [];

	//> レイヤーグループ用
	var group_reg		= new RegExp(REG_GROUP_NAME, "g");
	var noteDel_reg		= new RegExp(REG_COMMENT + ".*");
	var groupDel_reg	= new RegExp(REG_GROUP_DELIMITER + ".*");
	var shadeDel_reg	= new RegExp(REG_SHADE);
	var groups;
	var prevName		= "";
	var groupCount		= 0;
	var layerName;
	var layer;
	var len			= layersList.length;
	var progress	= 0;
	for(var i = 0; i < len; i++){

		layer	= layersList[i];

		//--> 階層名を追加しグループ名を除去したレイヤー名を取得
		layerName	= getLayerNameWithParent(layer, groupDel_reg, shadeDel_reg, noteDel_reg);

		if(layerName == ""){
			layerName	= " ";
		}else{
			layerName	= FileUtil.replaceDonotUseChar(layerName, FILE_NAME_REPLACE_CHAR);
		}

		//--? グループが関連付けられたレイヤーか（注釈部分は除外）
		groups	= layer.name.replace(noteDel_reg, "").match(group_reg, "g");
		if(groups){
			if(prevName != layerName){
				groupCount	= 1;	//※マッチしたリストの[0]は基本名なので[1]から始める
				prevName	= layerName;
			}
			//--> グループ名を順次足していく
			if(groups[groupCount]){
				layerName	+= groups[groupCount];
			}
			groupCount++;
		}else{
			prevName	= layerName;
			groupCount	= 0;
		}

		//--> 名前を適用
		targetLayerNames[i]	= layerName;

		//--> 進捗
		if(eventHandler){
			eventHandler.info	= layerName;
			eventHandler.onProgress(50 + Math.round((i + 1) / len * 50));	//50…getTargetLayersと合わせて100%
		}

	}

	return targetLayerNames;

};


///{$} レイヤー名を取得・レイヤーセットに格納されたレイヤーなら階層順にセット名を先頭に追加
function getLayerNameWithParent(layer, groupDel_reg, shadeDel_reg, noteDel_reg) {

	var layerName	= StringUtil.getFullName(
		 layer
		,_config.data.TargetLayer.Delimiter
		,"LayerSet"
		//{} フィルタ
		,function(parentName, delimiter, totalName){
			if(parentName.indexOf(THROUGH_PREFIX) == 0){
				//(!) 先頭が除外記号ならスルーする
				return totalName;
			}else{
				//--> グループ記号以降は除外する
				return (
					parentName.replace(FILE_TYPE_REG, "").replace(groupDel_reg, "").replace(shadeDel_reg, "").replace(noteDel_reg, "").replace(/[ \t　]+/g, "") +
					(totalName ? (FOLDER_SUFFIX_REG.test(parentName) ? "" : delimiter) : "") +
					totalName
				)
			}
		}
	);

	return layerName;

};


///{:e} 書き出し実行
function exportLayers() {

	var data		= _config.data;
	var global		= _config.global;
	var directly	= data.directly;

	global.docWidth	= parseInt(activeDocument.width);
	global.docHeight= parseInt(activeDocument.height);

	//--? 直実行の場合ここで確認ダイアログを表示	//※【未完】＞confirmMessageで対応
	if(directly){
		if(!_config.confirmAs(getExportFormat(directly) + CONFIRM_EXPORT, _resonance.windowTitle)){
			return;
		}
		_config.untouchable();
	}

	activeDocument.selection.deselect();

	global.saveFileType	= _config.getListValue("SaveFormat.FileType");
	//--? 直実行の場合開始してから対象レイヤーを取得
	if(directly){
		global.targetLayers	= getTargetLayers(
			 activeDocument.layers
			,data.TargetLayer.VisibleOnly
			,data.TargetLayer.Included
		);
		global.layerNames	= getLayerNames(global.targetLayers);
	}
	var targetLayersCount	= global.targetLayers.length;
	//--? 保存対象がなければキャンセル
	if(!targetLayersCount){
		throw new Error(ERROR_NOT_TARGET_LAYERS);
	}

var sw	= new Stopwatch(false);
sw.start();

	//> 保存先設定
	var SaveFormat	= data.SaveFormat;
	global.exportPath	= FileUtil.adjustPath(SaveFormat.Path, global.documentPath);
	var prefix		= SaveFormat.Prefix;
	var suffix		= SaveFormat.Suffix;
	var fileType	= _config.getListValue("SaveFormat.FileType");

	//--> ログ準備
	global.log_tc	= new TagConverter(convertPathTag(getLogFilePath()), _config.getListValue("Log.Encoding"), _config.getListValue("Log.Mode"));

	//--> 保存先フォルダを正式に取得（無ければユーザーに確認してから作る）
	var save_folder	= FileUtil.provideFolder(convertPathTag(global.exportPath), SaveFormat.ConfirmEnabled);

	//{--} 表示中の全レイヤーを保存
	var current_doc			= activeDocument;
	var targetLayers		= global.targetLayers;
	var layerNames			= global.layerNames;
	var filePrefix			= global.exportPath + "/" + prefix;
	var note_reg			= new RegExp(REG_COMMENT + ".*");
	var noteExtract_reg		= new RegExp("^.*" + REG_COMMENT);
	var fileSuffix			= suffix + fileType;
	var saveLayersCount		= 0;
	var emptyLayersCount	= 0;
	var len		= targetLayers.length;
	for(var i = 0; i < len; i++){
		//--? 途中でキャンセルされたら中断
		if(global.canceled){
			break;
		}
		if(exportLayer(targetLayers[i], layerNames[i], targetLayers, layerNames, save_folder, note_reg, noteExtract_reg)){
			//(!) 保存成功
			saveLayersCount++;
		}else{
			//(!) 保存失敗
			emptyLayersCount++;
		}
		activeDocument	= current_doc;
	}

	//--? 途中でキャンセルされたらそのまま終了
	if(global.canceled){
		_config.alertAs(ALERT_CANCEL);
		return;
	}

	//--> 書き出しログ出力
	if(saveLayersCount){
		saveLog();
	}

sw.stop();

	//--> 結果表示
	_config.alertAs(
		 getResultMessage(targetLayersCount, saveLayersCount, emptyLayersCount)
		,TITLE_RESULT + _config.global.count
	);

};


///{?} 指定されたレイヤー画像を保存する
function exportLayer(layer, fileName, targetLayers, targetLayerNames, save_folder, note_reg, noteExtract_reg) {

	var global			= _config.global;
	var data			= _config.data;
	var CropInBounds	= data.CropInBounds;
	var FixedLayer		= data.FixedLayer;
//alert(FixedLayer.Enabled+ "\nSingleSave:" +FixedLayer.SingleSave+ "\nBackground:" +FixedLayer.Background+ "\t" +layer.isBackgroundLayer+ "\nPrefix:[" +FixedLayer.Prefix+"]\t"+fileName.indexOf(FixedLayer.Prefix))
	//--? 特定のレイヤーは門前払い
	if(
		//(!) レイヤー名先頭が非書き出し記号の場合
		(layer.name.indexOf(SHADE_PREFIX) == 0)
		||
		//(!) レイヤーにピクセルが存在しない場合
		(!LayerUtil.isPixelInLayer(layer, CropInBounds.OverPixelsProtected))
		||
		//(!) 単独書き出し無効設定時の常表示レイヤー
		(
			FixedLayer.Enabled
			&&
			!FixedLayer.SingleSave
			&&
			(
				(FixedLayer.Background && layer.isBackgroundLayer)
				||
				(FixedLayer.Prefix != "" && layer.name.indexOf(FixedLayer.Prefix) == 0)
			)
		)
	){
		return false;
	}

	var SaveFormat	= data.SaveFormat;
	var cropType	= data.CropInBounds.Type;
	var Resize		= data.Resize;

	var getBoundsOf		= LayerUtil.getBoundsOf;
	var selectLayerMask	= LayerUtil.selectLayerMask;

	var fileType	= _config.getListValue("SaveFormat.FileType");
	var overPixelsProtected	= ((cropType != INDEX_NOT_CROP) && CropInBounds.OverPixelsProtected);

	//--> 注釈を取得（なければ親レイヤーセットの注釈を参照）
	var note	= note_reg.test(layer.name) ? layer.name.replace(noteExtract_reg, "").replace(FILE_TYPE_REG, "") : "";
	var fullNote= note;
	var noteDelimiter	= data.TargetLayer.Delimiter;
	var parent	= layer.parent;
	var s;
	while(parent.typename == "LayerSet"){
		if(note_reg.test(parent.name)){
			s	= parent.name.replace(noteExtract_reg, "");
			if(s){
				fullNote	= s + noteDelimiter + fullNote;
			}
		}
		parent	= parent.parent;
	}

	//> 書き出し先のフルパスを取得
	var saveFileName = FileUtil.replaceDonotUseChar(
		 convertPathTag(SaveFormat.Prefix + fileName + SaveFormat.Suffix).replace(NOTE_TAG_REG, note).replace(FULL_NOTE_TAG_REG, fullNote).replace(SPACE_REG, "")
		,FILE_NAME_REPLACE_CHAR
	);

	//> 保存形式を取得
	var saveFileType	= FILE_TYPE_REG.test(layer.name) ?
		"." + RegExp.$1.replace(FILE_TYPE_EXTRACT_REG, "").toLowerCase()
		:
		global.saveFileType;

	//> 切り抜き範囲
	var cropBounds;

	//--> 保存作業用のテンポラリドキュメントを生成
	var baseDocument	= activeDocument;
	var tempDocument	= LayerUtil.duplicateEmptyDocument();
	global.temp_doc	= tempDocument;
	var default_layer	= tempDocument.layers[0];
	default_layer.name	= TEMPORARY_LAYER_NAME;

	//{} テンポラリドキュメントの無保存終了
	var closeTempDocument	= function(){
		tempDocument.close(SaveOptions.DONOTSAVECHANGES);
		global.temp_doc	= null;
	};

	activeDocument	= baseDocument;

	//--? グループ情報がある場合は名前の末尾のグループ名を取得
	var group_reg	= new RegExp(REG_GROUP_NAME, "g");
	var groups		= layer.name.match(group_reg);
	groups.shift();	//先頭は基本名なので除外
	var groupsLength	= groups.length;
	var groupOn;
	var groupName;
	if(groupsLength){
		groupOn	= true;
		//--? 現在の書き出しレイヤーと対応するグループ名を取得
		var index;
		for(var i = 0; i < groupsLength; i++){
			index	= fileName.indexOf(groups[i]);
			if(index != -1 && index == fileName.length - groups[i].length){
				groupName	= groups[i].toLowerCase();
				break;
			}
		}
	}else{
		groupOn	= false;
	}

	//{--} テンポラリドキュメントに有効レイヤーを複製
	var bgCopy_layer;
	var topCopy_layer;
	if(targetLayers.length > 0){
		fileName			= fileName.toLowerCase();
		var isAlwaysVisible	= FixedLayer.Enabled;
		var prefixEnabled	= (FixedLayer.Prefix != "");
		var prefix			= FixedLayer.Prefix;
		var background		= FixedLayer.Background;
		var name;
		var target_layer;
		var temp_layer;
		for(var j = targetLayers.length - 1; j >= 0; j--){
			name	= targetLayerNames[j].toLowerCase();
			target_layer	= targetLayers[j];
			if(
				//(!) レイヤー名先頭が非書き出し記号の場合は除外
				(target_layer.name.indexOf(SHADE_PREFIX) != 0)
				&&
				(
					//(!) 同名レイヤー
					name == fileName
					||
					//(!) 常表示レイヤー
					(
						isAlwaysVisible
						&&
						(
							(background && target_layer.isBackgroundLayer)
							||
							(prefixEnabled && target_layer.name.indexOf(prefix) == 0)
						)
					)
					||
					//(!) グループに一致するレイヤー
					(groupOn && name == groupName)
				)
			){
				if(target_layer.isBackgroundLayer){
					//(!) 背景レイヤー
					bgCopy_layer	= target_layer.duplicate(tempDocument);
				}else{
					target_layer.duplicate(tempDocument);
				}
			}
		}
	}

	//--? 親レイヤーマスク範囲を取得
	if(cropType == INDEX_CROP_AS_PARENT){
		while(layer.parent.typename == "LayerSet"){
			activeDocument.activeLayer	= layer	= layer.parent;
			if(selectLayerMask()){
				var maskRange_layer	= activeDocument.artLayers.add();
				activeDocument.activeLayer	= maskRange_layer;
				activeDocument.selection.fill(foregroundColor);
				var bounds	= maskRange_layer.bounds;
				cropBounds	= bounds.concat();	//※プログラムエラー回避のための値渡し
				activeDocument.selection.deselect();
				maskRange_layer.remove();
				break;
			}
		}
	}

	activeDocument	= tempDocument;

	//{--} 全表示化
	var tempLayers	= activeDocument.layers;
	var len	= tempLayers.length;
	for(var k = 0; k < len; k++){
		tempLayers[k].visible	= true;
	}

	//--> 本来背景レイヤーだったものを背景に戻す
	if(bgCopy_layer){
		bgCopy_layer.isBackgroundLayer	= true;
	}

	//--> ドキュメントごとリサイズ（切り抜き前）
	if(Resize.Enabled && !Resize.AfterCrop){
		LayerUtil.resizeDocument(
			 tempDocument
			,Resize.Width
			,Resize.Height
			,_config.getListValue("Resize.ResampleType")
			,_config.getListValue("Resize.Mode")
		);
	}

	//--? 画面外を含めないなら全レイヤーを結合
	//※しないとレイヤーマスクに対して切り抜き範囲の算出が狂う・画面外含める設定だと狂いが残る
	var temp2Document;
	if(!overPixelsProtected){
		if(fileType == PSD_EXTENSION){
			//(!) PSDの場合・切り抜き範囲算出用に書き出し先ドキュメントのテンポラリを更に作る
			temp2Document	= tempDocument.duplicate();
			activeDocument	= temp2Document;
			activeDocument.mergeVisibleLayers();
		}else{
			//(!) PSD以外はそのまま結合
			tempDocument.mergeVisibleLayers();
		}
	}

	//--> 書き出しログ・切り抜き用の矩形領域算出
	switch(cropType){
		//(!) 書き出し対象の各レイヤーから切り抜き範囲を算出する場合
		case INDEX_CROP_AS_EACH:
			cropBounds	= adjustBounds(getBoundsOf(activeDocument.layers), activeDocument);
			break;
		//(!) 親レイヤーセットのレイヤーマスク範囲で切り抜く場合
		case INDEX_CROP_AS_PARENT:
			if(cropBounds){
				break;
			}
		default:
			cropBounds	= [0, 0, parseInt(activeDocument.width), parseInt(activeDocument.height)]
			break;
	}

	//--? 結合用テンポラリドキュメントから範囲を取得していた場合それを閉じる
	if(temp2Document){
		temp2Document.close(SaveOptions.DONOTSAVECHANGES);
		activeDocument	= tempDocument;
	}

	//--? PSDの場合はテンポラリ初期レイヤーを削除
	if(fileType == PSD_EXTENSION){
		default_layer.remove();
	}

	//--> ピクセル存在範囲の切り抜き
	if(cropType != INDEX_NOT_CROP){
		//--? 切り抜き範囲が存在すれば
		if(cropBounds[0] || cropBounds[1] || cropBounds[2] || cropBounds[3]){
			//--> 切り抜き
			try{
				tempDocument.crop(cropBounds);
			}catch(e){
				cropOnOverPixels(tempDocument, cropBounds);
			}
		}
	}

	//--> ドキュメントごとリサイズ（切り抜き後）
	if(Resize.Enabled && Resize.AfterCrop){
		LayerUtil.resizeDocument(
			 tempDocument
			,Resize.Width
			,Resize.Height
			,_config.getListValue("Resize.ResampleType")
			,_config.getListValue("Resize.Mode")
		);
	}

	//--? 最終位置情報を取得
	var finalBounds	= getBoundsOf(tempDocument.layers);
	if(fileType == PSD_EXTENSION){
		finalBounds	= adjustBounds(finalBounds, tempDocument);
	}

	//--? 対象が空レイヤーの場合キャンセル
	if(!finalBounds[0] && !finalBounds[1] && !finalBounds[2] && !finalBounds[3]){
		closeTempDocument();
		return false;
	}

	//--> 座標設定リストにレイヤーのデータを追加
	addLogData((Resize.Enabled && Resize.AfterCrop) ? finalBounds : cropBounds, tempDocument, saveFileName, saveFileType, note, fullNote);

	//--? 非透過時は透明部分を背景色で塗り潰し
	if(!SaveFormat.Transparent && !bgCopy_layer){
		var bg_layer	= tempDocument.artLayers.add();
		bg_layer.isBackgroundLayer	= true;
		tempDocument.activeLayer	= bg_layer;
		tempDocument.selection.selectAll();
		tempDocument.selection.fill(backgroundColor);
		tempDocument.selection.deselect();
		//--? PSD形式での書き出しならレイヤー統合
		if(global.saveFileType == PSD_EXTENSION){
			tempDocument.flatten();
		}
	}

	//--> 書き出し準備
	var save_file	= new File(save_folder + "/" + saveFileName + fileType);

	try{
		FileUtil.provideFolder(save_file.path, SaveFormat.ConfirmEnabled);
	}catch(e){
		closeTempDocument();
		return false;
	}

	//--? 同名ファイルが既に存在する場合の対応
	if(save_file.exists){
		if(!backupTo(save_file)){
			closeTempDocument();
			return false;
		}
	}

	//--? GIFだけはこの時点で未統合だと次で「統合しますか？」というダイアログが出てしまう。
	if(fileType == GIF_EXTENSION && (tempDocument.layers.length > 1 || tempDocument.layers[0].typename == "LayerSet")){
		var gifLayers		= tempDocument.layers;
		var visibleCount	= 0;
		var gifLen			= gifLayers.length;
		for(var l = 0; l < gifLen; l++){
			if(gifLayers[l].visible){
				visibleCount++;
			}
		}
		if(visibleCount > 1){
			tempDocument.mergeVisibleLayers();
		}
	}

	//--> 書き出し（同名ファイルは上書き）
	tempDocument.saveAs(save_file, getSaveOptions(saveFileType), true);

	closeTempDocument();

	return true;
};


///{$} 出力先パス用のタグを変換
function convertPathTag(path) {

	var global	= _config.global;

	var path_tc	= new TagConverter();

	path_tc.addTemplate("item", path);
	path_tc.addGlobalTag(NAME_TAG,		_resonance.documentName);
	path_tc.addGlobalTag(ID_TAG,		_resonance.documentID);
	path_tc.addGlobalTag(GUIDE_TAG,		_resonance.documentGuide);
	path_tc.addGlobalTag(COUNT_TAG,		global.count);
	path_tc.addGlobalTag(COUNT2_TAG,	global.countValue);
	path_tc.addItem({});

	return path_tc.convert();

};


///{} 書き出し回数カウントを進める
function countUp() {

	var global	= _config.global;

	global.countValue	= _config.data.Counter.Value;
	global.count		= COUNT_PREFIX + StringUtil.supply0To(global.countValue, _config.getListValue("Counter.Figure"));

	if(global.countValue < COUNT_MAX_VALUE){
		_config.data.Counter.Value++;
	}

};


///{?} 同名ファイルへの対応を設定に従い行い上書き可能か真偽を返す
function backupTo(file) {

	var data	= _config.data;
	var Backup	= data.Backup;

	switch(Backup.Type){

		case INDEX_BACKUP_CONFIRM:
			//(!) 確認ダイアログを出す
			var result	= data.confirmed ? FileUtil.confirmOfOverWrite(file) :  "a";
			switch(result){
				case "y":	//yes
					return true;
				case "c":	//cancel
					_config.global.canceled	= true;
					return false;
				case "a":	//all over writel
					Backup.Type	= INDEX_BACKUP_OVER_WRITE;
					return true;
				case "n":	//no
				default:
					return false;
			}

		case INDEX_BACKUP_NONE:
			return false;

		case INDEX_BACKUP_FOLDER:
			//(!) 所定のフォルダに待避
			//--? バックアップフォルダの取得
			var backup_folder;
			var global		= _config.global;
			var SaveFormat	= data.SaveFormat;
			FileUtil.adjustPath(SaveFormat.Path, global.documentPath);
			backup_folder	= FileUtil.provideFolder(
				FileUtil.adjustPath(
					 convertPathTag(Backup.Path ? Backup.Path : SaveFormat.Path + "/" + folderName)
					,global.documentPath
				)
			,SaveFormat.ConfirmEnabled);
			//--> バックアップ実行
			file.copy(backup_folder + "/" + file.name);
			break;

		case INDEX_BACKUP_OVER_WRITE:
		default:
			//(!) そのまま上書き
			break;

	}

	return true;

};


///{} 表示位置設定データに追加
function addLogData(bounds, document, fileName, saveFileType, note, fullNote) {

	//--? 書き出しログが無効ならキャンセル
	if(_config.data.Log.Type == INDEX_LOG_DONOT_SAVE){
		return;
	}

	var global				= _config.global;
	var CropInBounds		= _config.data.CropInBounds;
	var OverPixelsProtected	= CropInBounds.OverPixelsProtected;

	//--> ピクセルが存在する範囲を取得
	var x1 = parseInt(bounds[0]);
	var y1 = parseInt(bounds[1]);
	var x2 = parseInt(bounds[2]);
	var y2 = parseInt(bounds[3]);
	var docWidth	= global.docWidth;
	var docHeight	= global.docHeight;

	//--? 空白保護の設定に座標指定を対応
	if(CropInBounds.LeftProtected){
		x1 = OverPixelsProtected ? (x1 > 0 ? 0 : x1) : 0;
	}
	if(CropInBounds.TopProtected){
		y1 = OverPixelsProtected ? (y1 > 0 ? 0 : y1) : 0;
	}

	//--? 画面外を含まない設定の場合はみ出した分の座標を無視
	if(!OverPixelsProtected){
		if(x1 < 0){
			x1 = 0;
		}
		if(y1 < 0){
			y1 = 0;
		}
		x2 = (x2 > docWidth)  ? docWidth  : x2;
		y2 = (y2 > docHeight) ? docHeight : y2;
	}

	//--> レイヤーの幅を算出
	var width	= Math.abs(x2 - x1);
	var height	= Math.abs(y2 - y1);

	//--? 個別にフォルダ指定を含んでいる場合分割
	var path	= "";
	if((/[\/\\]/).test(fileName)){
		path	= fileName.replace(/[^\/\\]+$/, "").replace(/\\/g, "/");
		fileName= fileName.replace(/^.*[\/\\]/, "");
	}

	global.log_tc.addItem({
		 name	: fileName
		,type	: saveFileType
		,x		: x1
		,y		: y1
		,x2		: x2
		,y2		: y2
		,w		: width
		,h		: height
		,sub	: path
		,note	: note
		,fullNote	: fullNote
	});

};


///{} 表示座標の一覧ファイルを更新
function saveLog() {

	var data	= _config.data;
	var global	= _config.global;
	var Log		= data.Log;

	//--? 書き出しログが無効ならキャンセル
	if(Log.Type == INDEX_LOG_DONOT_SAVE){
		return;
	}

	//> タグ変換オブジェクト
	var tc	= global.log_tc;

	//> 共通タグ設定
	tc.addGlobalTag(COUNT_TAG,	global.count);
	tc.addGlobalTag(COUNT2_TAG,	global.countValue);
	tc.addGlobalTag(BASE_TAG,	new File(convertPathTag(global.documentPath) + "/" + _resonance.documentName + PSD_EXTENSION).fsName);
	tc.addGlobalTag(PATH_TAG,	convertPathTag(global.exportPath));
//	tc.addGlobalTag(TYPE_TAG,	_config.getListValue("SaveFormat.FileType"));

	//> 個別タグ設定
	tc.addTag(NAME_TAG);
	tc.addTag(SUB_TAG);
	tc.addTag(TYPE_TAG);
	tc.addTag(X_TAG);
	tc.addTag(Y_TAG);
	tc.addTag(X2_TAG);
	tc.addTag(Y2_TAG);
	tc.addTag(WIDTH_TAG);
	tc.addTag(HEIGHT_TAG);
	tc.addTag(NOTE_TAG);
	tc.addTag(FULL_NOTE_TAG);

	//--> 書式設定
	tc.addTemplate("head",	Log.HeadForm);
	tc.addTemplate("top",	Log.TopForm);
	tc.addTemplate("item",	Log.ItemForm);
	tc.addTemplate("bottom",Log.BottomForm);
	tc.addTemplate("foot",	Log.FootForm);

	//--> テンプレートに基づいてタグ変換＆ファイル保存
	tc.saveOnConvert(_resonance.windowTitle);

};


///{$} 書き出しログファイルのパスを取得
function getLogFilePath() {

	var Log	= _config.data.Log;

	var basePath;
	if(Log.Type == INDEX_LOG_WITH_TARGET){
		//(!) 書き出し先と同フォルダ
		basePath	= _config.global.exportPath;
	}else{
		//(!) 書き出し元と同フォルダ
		basePath	= _config.global.documentPath;
	}

	var count	= (Log.Mode == INDEX_LOG_WITH_COUNT) ? _config.global.count : "";

	//<-- 書き出し元ドキュメント名を含めて返す
	return basePath + "/" + LOG_FILE_NAME_PREFIX + _resonance.documentName + LOG_FILE_NAME_SUFFIX + count + "." + Log.FileType;

};


///{?} 指定したレイヤーのピクセル存在範囲を切り抜きその成否を返す
function adjustBounds(bounds, document) {

	var CropInBounds		= _config.data.CropInBounds;
	var leftProtected		= CropInBounds.LeftProtected;
	var topProtected		= CropInBounds.TopProtected;
	var rightProtected		= CropInBounds.RightProtected;
	var bottomProtected		= CropInBounds.BottomProtected;
	var overPixelsProtected	= CropInBounds.OverPixelsProtected;

	//--? 切り抜く必要がなければキャンセル
	if(
		(_config.data.CropInBounds.Type == INDEX_NOT_CROP)
		||
		(leftProtected && topProtected && rightProtected && bottomProtected && !overPixelsProtected)
	){
		return [0, 0, parseInt(document.width), parseInt(document.height)];
	}

	//--> ピクセルが存在する範囲を取得
	var x1 = parseInt(bounds[0]);
	var y1 = parseInt(bounds[1]);
	var x2 = parseInt(bounds[2]);
	var y2 = parseInt(bounds[3]);
	if(isNaN(x1))	x1	= 0;
	if(isNaN(y1))	y1	= 0;
	if(isNaN(x2))	x2	= 0;
	if(isNaN(y2))	y2	= 0;
	var width	= parseInt(document.width);
	var height	= parseInt(document.height);

	//--> 四方の空白保護設定を適用
	if(leftProtected && x1 > 0){
		x1 = 0;
	}
	if(topProtected && y1 > 0){
		y1 = 0;
	}
	if(rightProtected && x2 < width){
		x2 = width;
	}
	if(bottomProtected && y2 < height){
		y2 = height;
	}

	//--> 画面外の表示範囲外を含めるかどうかの設定を適用
	if(!overPixelsProtected){
		if(x1 < 0)	x1 = 0;
		if(y1 < 0)	y1 = 0;
		if(x2 < 0)	x2 = 0;
		if(y2 < 0)	y2 = 0;
		if(x2 > width)	x2 = width;
		if(y2 > height)	y2 = height;
	}

	//--? 横か縦のどちらかのピクセルが無効ならすべて無効
	if((!x1 && !x2) || (!y1 && !y2)){
		x1	= x2	= y1	= y2	= 0;
	}

	return [x1, y1, x2, y2];

};


///{} ドキュメントの画面外にしかピクセルが存在しない状態でその存在範囲を切り抜く
function cropOnOverPixels(document, bounds) {

	var width				= parseInt(document.width);
	var height				= parseInt(document.height);
	var leftMargin			= (bounds[0] < 0)		? Math.abs(bounds[0]) : 0;
	var topMargin			= (bounds[1] < 0)		? Math.abs(bounds[1]) : 0;
	var rightMargin			= (bounds[2] > width)	? (bounds[2] - width) : 0;
	var bottomMargin		= (bounds[3] > height)	? (bounds[3] - height): 0;
	var horizontalMargin	= (leftMargin > rightMargin) ? leftMargin : rightMargin;
	var verticalMargin		= (topMargin > bottomMargin) ? topMargin : bottomMargin;
	var resizeWidth			= width + horizontalMargin * 2;
	var resizeHeight		= height + verticalMargin * 2;

	//--> ピクセルが存在する範囲までカンバスサイズを拡大
	document.resizeCanvas(resizeWidth, resizeHeight);

	//--> 拡大したカンバスからピクセル存在範囲を取得
	var renewedBounds		= LayerUtil.getBoundsOf(document.layers);

	//--? 四方空白保護設定を適用・カンバス拡大前の四方空白量を切り抜き範囲に反映
	var pixelsWidth		= (renewedBounds[2] - renewedBounds[0]);
	var pixelsHeight	= (renewedBounds[3] - renewedBounds[1]);
	if(!bounds[0] && _config.data.CropInBounds.LeftProtected){
		renewedBounds[0]	-= bounds[2] - pixelsWidth;
	}
	if(!bounds[1] && _config.data.CropInBounds.TopProtected){
		renewedBounds[1]	-= bounds[3] - pixelsHeight;
	}
	if(_config.data.CropInBounds.RightProtected){
		var rightPadding	= width - (bounds[0] + pixelsWidth);
		if(rightPadding > 0){
			renewedBounds[2]	+= rightPadding;
		}
	}
	if(_config.data.CropInBounds.BottomProtected){
		var bottomPadding	= height - (bounds[1] + pixelsHeight);
		if(bottomPadding > 0){
			renewedBounds[3]	+= bottomPadding;
		}
	}

	document.crop(renewedBounds);

};


///{o} ファイルタイプ別セーブオプション取得
function getSaveOptions(saveFileType) {

	var save_options;

	switch(saveFileType){

		case BMP_EXTENSION:
			save_options = new BMPSaveOptions();
			break;

		case JPG_EXTENSION:
		case JPEG_EXTENSION:
			save_options = new JPEGSaveOptions();
			save_options.quality		= _config.getListValue("JpegFormat.Quality");
			save_options.formatOptions	= _config.getListValue("JpegFormat.Format");
			//--? スキャン値を設定すると自動的にプログレッシブ保存になるのでそれ以外の形式では避ける
			if(save_options.formatOptions == FormatOptions.PROGRESSIVE){
				save_options.scans		= _config.getListValue("JpegFormat.Scans");
			}
			break;

		case GIF_EXTENSION:
			save_options = new GIFSaveOptions();
			break;

		case PSD_EXTENSION:
			save_options = new PhotoshopSaveOptions();
			break;

		case PNG_EXTENSION:
		default:
			save_options = new PNGSaveOptions();
			break;

	}

	return save_options;

};


///{$} 書き出し形式取得
function getExportFormat(detailAdded){

	var SaveFormat	= _config.data.SaveFormat;
	var TargetLayer	= _config.data.TargetLayer;
	var TargetLayerInfo	= _config.infoData.TargetLayer;

	//--? 直実行の場合は対象レイヤー設定も表示
	var detail	= "";
	if(detailAdded){
		function f(b){
			return b ? "Yes" : "No";
		}
		detail	= NEW_LINE2 +
			TargetLayerInfo.VisibleOnly.replace(/\(.*/, ":") + INDENT + f(TargetLayer.VisibleOnly) + NEW_LINE +
			TargetLayerInfo.Included.replace(/\(.*/, ":") + INDENT + f(TargetLayer.Included) + NEW_LINE +
			TargetLayerInfo._Delimiter + INDENT + '"' + TargetLayer.Delimiter + '"'
	}

	return '"' + new File(
		FileUtil.adjustPath(convertPathTag(SaveFormat.Path), _config.global.documentPath) + "/" + 
		convertPathTag(SaveFormat.Prefix + _config.infoData.SaveFormat._layerName + SaveFormat.Suffix) +
		_config.getListValue("SaveFormat.FileType")
	).fsName + '"' + detail;

};


///{$} 結果一覧メッセージ取得
function getResultMessage(visibleLayers, saveLayersCount, emptyLayersCount){

	return NEW_LINE	+ MESSAGE_RESULT_FORMAT			+ INDENT + getExportFormat() +
		NEW_LINE2	+ MESSAGE_RESULT_ALL_LAYERS		+ INDENT + visibleLayers +
		NEW_LINE2	+ MESSAGE_RESULT_SAVED_LAYERS	+ INDENT + saveLayersCount +
		NEW_LINE	+ MESSAGE_RESULT_EMPTY_LAYERS	+ INDENT + emptyLayersCount +
		NEW_LINE2;

};


///{} ログ書式ヘルプ表示
function showLogHelp(){

	var dlg	= new Window("dialog", TITLE_LOG_HELP);

	dlg.orientation	= "column";

	var main_grp	= dlg.add("group");

	main_grp.alignChildren	= "top";
	var left_grp	= main_grp.add("group");
	var right_grp	= main_grp.add("group");
	right_grp.orientation	= left_grp.orientation	= "column";

	var option		= {multiline:true, readonly:true};

	var global_pnl	= left_grp.add("panel", undefined, PANEL_LOG_GLOBAL_HELP);
	var global_stx	= global_pnl.add("edittext", undefined, TEXT_LOG_GLOBAL_HELP, option);

	var date_pnl	= left_grp.add("panel", undefined, PANEL_LOG_DATE_HELP);
	var date_stx	= date_pnl.add("edittext", undefined, TEXT_LOG_DATE_HELP, option);

	var item_pnl	= right_grp.add("panel", undefined, PANEL_LOG_ITEM_HELP);
	var item_stx	= item_pnl.add("edittext", undefined, TEXT_LOG_ITEM_HELP, option);

	global_stx.preferredSize.width	= item_stx.preferredSize.width	= date_stx.preferredSize.width	= 200;
	item_stx.preferredSize.width	= 240;
	global_stx.preferredSize.height	= 100;
	date_stx.preferredSize.height	= 180;
	item_stx.preferredSize.height	= 320;

	dlg.add("statictext", undefined, TEXT_LOG_NOTE_HELP);

	var button_grp	= dlg.add("group");
	var ok_btn		= button_grp.add("button", undefined, ConfigDialog.button.OK);
	ok_btn.onClick	= function(){
		dlg.close(true);
	};

	dlg.defaultElement	= ok_btn;

	dlg.center();
	return dlg.show();

};


