//※【未完】＞レイヤーセットの差分記号内に"|"が入っていると、レイヤーセット以下のスキップと誤認される事がある？
/**

///	差分レイヤー表示切替スクリプト

	制作：彩藤神楽	(http://www.re-sonance.com/)


	Copyright (C) 2007-2008 Saitoh Kagura, All Rights Reserved.

 */

const SCRIPT_TITLE	= "差分管理";
const VERSION		= "0.1.00";


///-------------------------------------------------------------
///	外部スクリプトファイル読み込み
//--------------------------------------------------------------
#include "./lib/Resonance.jsxinc"
#include "./lib/ScriptUtil.jsxinc"
#include "./lib/LayerCompUtil.jsxinc"
#include "./lib/StringUtil.jsxinc"
#include "./lib/FileUtil.jsxinc"
#include "./lib/ConfigDialog.jsxinc"
	//+ "./lib/DataUtil.jsxinc"

//DebugUtil.enabled	= true;	//※【未完】

///-------------------------------------------------------------
///	グローバル
//--------------------------------------------------------------

//--> 基礎準備
#target photoshop
app.bringToFront();
const NEW_LINE	= Resonance.NEW_LINE;
const NEW_LINE2	= NEW_LINE + NEW_LINE;
const INDENT	= Resonance.INDENT;
_resonance		= new Resonance(SCRIPT_TITLE, VERSION);

///> 差分記号接頭辞
const VARIATION_PREFIX			= _resonance.scriptSymbol;

///> 差分記号用定数
const PATTERN_DELIMITER		= ",";	//> レイヤー名で複数パターンを列記する際の区切り記号
const EXCEPT_PREFIX_REG		= /^\/[*\/]/;	//> レイヤー名の先頭にこの文字があると常に非表示となる
const OPTION_SETTING_REG	= /:[-+]{4}/;	//> メタデータから読み込む詳細設定用
const OPTION_ENABLED_CHAR	= "+";			//> メタデータから読み込む詳細設定の有効記号
const TEMP_DELIMITER_REG	= /#/g;

///> 表示切替タイプ定数
const TYPE_HIDE				= "0";
const TYPE_SHOW				= "1";
const TYPE_MASK_HIDE		= "2";
const TYPE_MASK_SHOW		= "3";

///> ファイル名埋め込み対応設定
const INDEX_FULL_PATTERN		= 1;
const INDEX_RIGIDLY_INSPECTED	= 2;
const INDEX_EMPTY_EXCEPTED		= 3;
const INDEX_SOME_EXCEPTED		= 4;

///> 差分記号用正規表現
function setVariationPrefixReg(global){
	//> 差分レイヤーか判定
	global.variationLayer_reg	= new RegExp("^" + VARIATION_PREFIX);
	//> 表示切替スキップレイヤー
	global.skip_reg				= new RegExp("^" + VARIATION_PREFIX + "!");
	//> サブレイヤーセット以降表示切替スキップレイヤー
	global.subSkip_reg			= new RegExp("\\|$");
	//> レイヤー名差分条件表記
	global.variation_reg		= new RegExp("^" + VARIATION_PREFIX + VARIATION_PREFIX + "?[^" + VARIATION_PREFIX + " /=＝　]+");
	//> レイヤー名から差分記号接頭辞のみ除外
	global.removePrefix_reg		= new RegExp("^" + VARIATION_PREFIX + VARIATION_PREFIX + "?");
	//> レイヤーマスクを切り替える差分記号か判定
	global.changeMask_reg		= new RegExp("^" + VARIATION_PREFIX + VARIATION_PREFIX);
	//> 更新時に削除するレイヤーカンプ名
	global.removeComp_reg		= new RegExp("^(" + VARIATION_PREFIX + "[^" + VARIATION_PREFIX + "]|" + _resonance.backupLayerCompName + "$)");
	//> 差分用（抽出用）レイヤーカンプ名
	global.variationComp_reg	= new RegExp("^" + VARIATION_PREFIX + ".+");
	//> 差分用レイヤーカンプ名から純粋な差分パターン名以外を削除して抽出
//	global.extractVariation_reg	= new RegExp("(^" + VARIATION_PREFIX + "|[" + VARIATION_PREFIX + " /=＝　].*)", "g");
	global.extractVariation_reg	= new RegExp("(^" + VARIATION_PREFIX + "|[ /=＝　].*)", "g");
};

//> グローバルに扱う設定系オブジェクト
var _config;

///> 確認ダイアログ
const TITLE_EXTRACTION			= "結合画像を抽出";
const CONFIRM_EXTRACTION		= "現在の差分用レイヤーカンプ群の設定に基づいて、" + NEW_LINE + "それぞれの表示状態を適用した結合画像を抽出します。" + NEW_LINE2 + "よろしいですか？" + NEW_LINE2;
const TITLE_RESULT				= "結合画像抽出完了 ";
const MESSAGE_RESULT			= "差分用レイヤーカンプに基づいて結合画像を抽出しました。";
const MESSAGE_SAVE_FORMAT		= "保存時のファイル名";

///> エラーメッセージ定数

const ERROR_VARIATION_LIST_FAIL	= "差分パターンが取得できませんでした。";
const ERROR_EXTRACT_FAIL		= "対象が存在しないため抽出できませんでした。";
var ProgressError				= function(){};
ProgressError.prototype			= new Error();


//> 設定データの標準値
var _configData	= {};
_configData.defaultData	= {
	 ScriptTitle		: SCRIPT_TITLE
	,ScriptVersion		: VERSION
	,Delimiter			: "_"
	,FullPattern		: true
	,RigidlyInspected	: true
	,EmptyExcepted		: true
	,SameExcepted		: true
	,RenewOnExtract		: true
	,SaveToSameDocument	: false
	,SaveFormat			: "差分抽出[<name>]"
	,Patterns			: []
	,PatternsHistory	: [["0-9"]]
};
_configData.infoData	= {
	 _left				: "現在の差分用レイヤーカンプ"
	,_right				: "差分判定条件"
	,_lastUpdate		: "最終更新日:"
	,_extractButton		: "結合画像を抽出(&E)"
	,_patternEdit		: "条件:"
	,_upButton			: "↑"
	,_downButton		: "↓"
	,_addButton			: "追加"
	,_applyButton		: "適用"
	,_removeButton		: "削除"
	,_history			: "履歴:"
	,_Delimiter			: "区切り記号:"
	,_renewButton		: "差分用レイヤーカンプを更新(&R)"
	,FullPattern		: "詳細パターンを取得"
	,RigidlyInspected	: "厳密に判定"
	,EmptyExcepted		: "空の差分を除外"
	,SameExcepted		: "同一状態の差分を除外"
	,RenewOnExtract		: "抽出時に自動的に更新する"
	,SaveToSameDocument	: "抽出PSDの自動保存"
	,_SaveFormatButton	: "保存名編集..."
//	,SaveToSameDocument	: "抽出結果のPSDファイルを同フォルダに保存"
};
_configData.helpData	= {
	 _metaTitle		: "差分判定条件"
};
_configData.widthData	= {
	 "_left,_right,_progressInfo,_progress"		: 230
	,_targetComps		: 200
	,Patterns			: 180
	,"_addPattern,PatternsHistory"		: 170
	,_renewButton	: 200
	,"_addButton,_removeButton"		: 100
	,"_extractButton,_progressInfo,_progress"		: 480
	,Delimiter	: 28
	,"_upButton,_downButton"	: 20
};
_configData.heightData	= {
	 "_left,_right"		: 250
	,"_targetComps"		: 150
	,"Patterns"			: 110
	,"_upButton,_downButton"	: 50
};



//--> 本体実行
main();


///-------------------------------------------------------------
///	メインフロー関数
//--------------------------------------------------------------

///{} 本体
function main() {

	//--? 起動時チェック
	try{
		ScriptUtil.inspectDocumentExists();
		ScriptUtil.inspectPhotoshopVersion();
		ScriptUtil.inspectDocumentFormat();
	}catch(e){
		_resonance.showError(e);
		return;
	}

	try{

		mainFlow();

	}catch(e){
		_resonance.showError(e);
	}

	//--> 一時記憶用レイヤーカンプが残っていたら全て破棄
	LayerCompUtil.removeLayerComps(activeDocument, _resonance.backupLayerCompName);

};


///{} メインフロー
function mainFlow() {

	//--> 設定読み込み
	loadConfig();

	//--? 設定ダイアログを表示してキャンセルされなければ一斉出力処理
	if(_config.show()){

		var basePath	= _resonance.documentParentPath;

		var saveName	= _resonance.replaceDocumentTag(_config.data.SaveFormat);
		//(!) レイヤーカンプから結合PSDを抽出
		var result_doc	= LayerCompUtil.extractionFromLayerComp(
			 activeDocument
			,_config.global.variation_reg
			,function(name){
				return name.replace(_config.global.removePrefix_reg, "");
			}
			,saveName
		);

		if(result_doc){
			//(!) 抽出成功
			if(_config.data.SaveToSameDocument){
				//(!) 抽出元ドキュメントと同フォルダに書き出し
				var save_file	= new File(((/^([\\\/]|[A-Z]:)/i).test(saveName) ? "" : basePath + "/") + saveName);
				FileUtil.provideFolder(save_file.parent, _config.data.confirmed);
				result_doc.saveAs(save_file, new PhotoshopSaveOptions(), false);
			}
			_config.alertAs(MESSAGE_RESULT, TITLE_RESULT);
		}else{
			throw new Error(ERROR_EXTRACT_FAIL);
		}

	}

};


///{} 設定読み込みその編集用ダイアログを配置
function loadConfig() {

	//--> XMLデータとダイアログ設定を関連付けるクラスを生成
	_config	= new ConfigDialog(_configData);
	ScriptUtil.tries(_resonance.windowTitle, _config.connectXMLON, _config, [
		 _resonance.configFilePath
		,SCRIPT_TITLE
		,VERSION
	]);

	//--> ダイアログ基本設定
	_config.title	= _resonance.windowTitle;


  ///{} ダイアログのレイアウトと設定データの対応を準備する
  _config.prepare	= function(){

	//--> 接頭辞更新
	setVariationPrefixReg(this.global);

	//--> ドキュメント名のオプションを取得して見つかればパターン定義に適用
	var metaData_str	= _resonance.getConfigMetaData();
	if(metaData_str){
		var option_match	= metaData_str.match(OPTION_SETTING_REG);
		if(option_match){
			var optionSetting	= option_match[0];
			this.data.FullPattern		= (optionSetting.charAt(INDEX_FULL_PATTERN) == OPTION_ENABLED_CHAR);
			this.data.RigidlyInspected	= (optionSetting.charAt(INDEX_RIGIDLY_INSPECTED) == OPTION_ENABLED_CHAR);
			this.data.EmptyExcepted		= (optionSetting.charAt(INDEX_EMPTY_EXCEPTED) == OPTION_ENABLED_CHAR);
			this.data.SameExcepted		= (optionSetting.charAt(INDEX_SOME_EXCEPTED) == OPTION_ENABLED_CHAR);
		}
		var optionPatterns	= metaData_str.replace(OPTION_SETTING_REG, "");
		if(optionPatterns){
			this.data.Patterns	= optionPatterns.split(",");
		}
	}

	const NARROW_SPACE	= ConfigDialog.NARROW_SPACE;
	const BROAD_SPACE	= ConfigDialog.BROAD_SPACE;

	const column_opt	= this.setOptions({orientation:"column", alignChildren:"left", alignment:"top"});
	const row_opt		= this.setOptions({orientation:"row"});
	const narrowColumn_opt	= this.setOptions({orientation:"column", spacing:NARROW_SPACE});
	const narrowRow_opt	= this.setOptions({orientation:"row", spacing:NARROW_SPACE});
	const charEdit_opt	= this.setOptions({orientation:"row", alignment:"right", spacing:NARROW_SPACE});

	//--> メインウィンドウ生成
	this.create();

	//--> メイングループ
	this.addGroup("_main", row_opt);

	//--> 左部パネル
	var left_pnl	= this.addPanel("_main/_left", column_opt, getLastUpdateOfComp(this));

	//--> 現在レイヤーカンプリスト
	this.addGroup("_main/_left/_compsList", column_opt);
		var targetComps_lbx	= this.addListBox("_targetComps");
		var renew_btn		= this.addButton("_renewButton", undefined, "onClickRenew");
		this.addCheckBox("RenewOnExtract");

	//--> 右部パネル
	this.addPanel("_main/_right", column_opt);

	//--> 差分条件リスト
	this.addGroup("_main/_right/_patterns", narrowColumn_opt);
		this.addGroup("_main/_right/_patterns/_list", narrowRow_opt);
			var patterns_lbx	= this.addEditListBox("Patterns");
			this.addGroup("_main/_right/_patterns/_list/_side", narrowColumn_opt);
				patterns_lbx.addUpButton("_upButton");
				patterns_lbx.addDownButton("_downButton");
		this.addGroup("_main/_right/_patterns/_edit", narrowRow_opt);
			this.addText("_patternEdit");
			var edit_etx	= this.addEditText("_addPattern", undefined, "onChangeEdit");
		this.addGroup("_main/_right/_patterns/_button", narrowRow_opt);
			patterns_lbx.addApplyButton(edit_etx, "_addButton");
			patterns_lbx.addRemoveButton("_removeButton");
			this.ascend();
		this.addGroup("_main/_right/_patterns/_history", {orientation:"row", spacing:NARROW_SPACE
			,margins:[0, BROAD_SPACE / 2, 0, BROAD_SPACE / 2]
		});
			this.addText("_history");
			this.global.history_ddl	= patterns_lbx.addHistoryMenu("PatternsHistory");
			this.ascend();
		this.addGroup("_main/_right/_patterns/_prefix", narrowRow_opt);
			//--> 差分記号区切り文字
			this.addText("_Delimiter");
			this.addEditText("Delimiter");

	//--> 詳細設定
	this.addGroup("_middle", row_opt);
		this.addCheckBox("FullPattern");
		this.addCheckBox("RigidlyInspected");
		this.addCheckBox("EmptyExcepted");
		this.addCheckBox("SameExcepted");

	//--> 進捗グループ
	this.addGroup("_progress", column_opt);
		var renew_stx	= this.addText("_progressInfo");
		var renew_prg	= this.addProgressBar("_progress");
		renew_prg.info_item	= renew_stx;

	//--> 下部ボタン
	this.changeRoot();
		this.addGroup("_cunfigButton");
			this.addConfirmCheckBox();
			this.addCheckBox("SaveToSameDocument");
			this.addButton("_SaveFormatButton", undefined, "onClickSaveFormat");
		this.ascend();
		this.addDefaultButton("_extractButton", undefined, "onClickExtract");
	this.addGroup("_button");
		this.addApplyButton("_applyConfigButton");
		this.addMetaDataButton();
		this.addResetButton();
		this.addCancelButton();

	///{$} レイヤーカンプの最終更新日時を取得
	function getLastUpdateOfComp(conf){
		var variationComp_reg	= conf.global.variationComp_reg;
		var layerComps		= activeDocument.layerComps;
		var prefix			= conf.infoData._lastUpdate;

		var newest	= "-";
		var layerComp;
		var len	= layerComps.length;
		for(var i = 0; i < len; i++){
			layerComp	= layerComps[i];
			if(variationComp_reg.test(layerComp.name)){
				if(!newest || layerComp.comment > newest){
					newest	= layerComp.comment;
				}
			}
		}

		return prefix + newest;

	};


	//{} 現在レイヤーカンプを取得
	function renewTargetLayerComps(conf){
		targetComps_lbx.removeAll();
		var variation_reg	= conf.global.variation_reg;
		var variationComps	= [];
		var layerComps		= activeDocument.layerComps;
		var layerComp;
		var len	= layerComps.length;
		for(var i = 0; i < len; i++){
			layerComp	= layerComps[i];
			if(variation_reg.test(layerComp.name)){
				variationComps.push(layerComp);
				targetComps_lbx.add("item", layerComp.name);
			}
		}
		left_pnl.text	= getLastUpdateOfComp(conf);
	};
	renewTargetLayerComps(this);


	/// イベントハンドラ

	var eventListener	= {};

	//e{} 抽出ボタンイベント
	eventListener.onClickExtract	= function(conf, item){
		if(conf.confirmAs(CONFIRM_EXTRACTION, TITLE_EXTRACTION)){
			//--? 自動的にレイヤーカンプを更新する場合
			if(conf.data.RenewOnExtract && renew_prg.value != 100){
				conf.dispatchEvent("onClickRenew", renew_btn);
			}
			conf.close(true);
		}
	};

	//e{} レイヤーカンプ更新ボタンイベント
	eventListener.onClickRenew	= function(conf, item){
		renew_prg.onStartProgress();
		try{
			renewLayerComp(activeDocument, renew_prg);
			renewTargetLayerComps(conf);
			renew_prg.onCompleteProgress();
		}catch(e){
		}
	};

	//e{} パターン編集テキストイベント
	eventListener.onChangeEdit	= function(conf, item){
		item.text	= item.text.replace(/[, 　]+/g, "|");
		conf.notEdited	= true;
	};


	///e{} 自動保存ファイル名編集ボタンイベント
	eventListener.onClickSaveFormat	= function(conf, item){
		conf.data.SaveFormat	= _resonance.editDocumentInfoTemplate(conf.data.SaveFormat, MESSAGE_SAVE_FORMAT);
	};


	///e{} メタデータ取得ボタンイベント
	eventListener.onClickMetaData	= function(conf, item){
		_resonance.setConfigMetaData(conf.helpData._metaTitle, conf.data.Patterns.join(","));
	};


	//e{} 設定保存イベント
	eventListener.onSave	= function(conf){
		conf.global.history_ddl.addHistory(conf.data.Patterns);
	};


	//e{} エラー表示イベント
	eventListener.onError	= function(conf, item, e){
		alert("<onError>" + e + "\n" + dump(item), Resonance.title.ERROR, true);	//※【未完】
	};

	//--> イベントリスナーを登録
	this.setListener(eventListener);

  };

};


///{} レイヤーカンプ生成・更新
function renewLayerComp(document, eventHandler){

	//--> 総差分パターン取得
	try{
		var variationList	= getVariationFromPatterns(document);
		if(!variationList){
			throw new Error(ERROR_VARIATION_LIST_FAIL);
		}
	}catch(e){
		_resonance.showError(e);
		return;
	}

	//--> 既存の差分用レイヤーカンプをすべて破棄
	LayerCompUtil.removeLayerComps(document, _config.global.removeComp_reg);

	//--> 現在の表示状態のバックアップレイヤーカンプを作成
	document.layerComps.add(_resonance.backupLayerCompName, "", false, false, true);
	var backup_comp	= activeDocument.layerComps.getByName(_resonance.backupLayerCompName);

	var current_layer	= activeDocument.activeLayer;

	//--> 差分数の分だけレイヤーカンプ生成
	try{
		createCompsOnVariation(document, variationList, eventHandler);
	}catch(e){
		if(!ConfigDialog.isCancelProgressError(e)){
			_resonance.showError(e);
		}
		eventHandler.onProgressError();
		throw new ProgressError();
	}

	activeDocument.activeLayer	= current_layer;

	//--> バックアップレイヤーカンプを適用後破棄
	backup_comp.apply();
	backup_comp.remove();

//DebugUtil.show();

};


///{a} 差分の総組み合わせ表を取得
function getVariationFromPatterns(document) {

	var Patterns	= _config.data.Patterns;
	var variations	= [];

	var between_reg	= /([0-9]\-[0-9]|[a-z]\-[a-z])/;
	var allPatterns	= [];
	var between, s, a;
	var len	= Patterns.length;
	for(var i = 0; i < len; i++){
		if(Patterns[i].indexOf("-") != -1){
			s	= Patterns[i];
			while(between_reg.test(s)){
				between	= RegExp.$1;
				s	= s.replace(between, StringUtil.getBetweenOf(between, "-").join(""));
			}
			a	= s.split("");
//			a	= StringUtil.getBetweenOf(Patterns[i].toLowerCase(), "-");
		}else if(Patterns[i].indexOf("|") != -1){
			a	= Patterns[i].split("|");
		}else{
			a	= [Patterns[i]];
		}
		allPatterns[i]	= a;
	}
//DebugUtil.add(allPatterns + " => "+DataUtil.mergeAllPatterns(allPatterns, VARIATION_PREFIX, _config.data.FullPattern));
	if(allPatterns.length){
		return DataUtil.mergeAllPatterns(allPatterns, VARIATION_PREFIX, _config.data.FullPattern);
	}else{
		return null;
	}

};


///{} 差分組み合わせ数の分だけレイヤーカンプ生成
function createCompsOnVariation(document, variationList, eventHandler) {

	eventHandler.onStartProgress();

	var targetLayers	= getTargetLayers(document.layers, [], eventHandler);

	createCompOnVariation(document.layerComps, targetLayers, variationList, eventHandler);

	eventHandler.onCompleteProgress();

};


///{} スキップ対象のレイヤーセット内のレイヤーはすべて表示化する。
function changeVisibleLayers(layerSet){

	var layers	= layerSet.layers;
	var layer;
	var len	= layers.length;
	for(var i = 0; i < len; i++){
		layer	= layers[i];
		layer.visible	= !EXCEPT_PREFIX_REG.test(layer.name);
		if(layer.typename == "LayerSet"){
			changeVisibleLayers(layer);
		}
	}

};


///r{a} 差分組み合わせ数の分だけレイヤーカンプ生成
function getTargetLayers(layers, list, eventHandler, parentProgress, parentLength) {

	if(!parentProgress){
		parentProgress	= 0;
	}
	if(!parentLength){
		parentLength	= 1;
	}

	var skip_reg			= _config.global.skip_reg;
	var subSkip_reg			= _config.global.subSkip_reg;
	var variationLayer_reg	= _config.global.variationLayer_reg;

	var layer;
	var name;
	var len	= layers.length;
	var max	= len * parentLength;
	var progress	= parentProgress;
	for(var i = 0; i < len; i++){
		if(!_config.isProgressing){
			throw new ConfigDialog.CancelProgressError();
		}
		layer	= layers[i];
		name	= layer.name;
		if(skip_reg.test(name)){
			continue;
		}
		if(EXCEPT_PREFIX_REG.test(name)){
			//(!) 非表示固定レイヤー
			if(layer.visible){
				layer.visible	= false;
			}
			continue;
		}else if(variationLayer_reg.test(name)){
			//(!) 差分用レイヤー
			list.push(layer);
		}else{
			//(!) 通常レイヤー
			if(!layer.visible){
				layer.visible	= true;
			}
		}
		if(layer.typename == "LayerSet" && !subSkip_reg.test(name)){
 			list	= getTargetLayers(layer.layers, list, eventHandler, progress, len * parentLength);
		}
		progress	= parentProgress + Math.round((i + 1) / max * 75);	//25%==createCompOnVariation
		eventHandler.info	= name;
		eventHandler.onProgress(progress);
	}

	return list;

};


///{?} 差分記号がすべて１文字の組み合わせかを返す
function isSingleChars(patterns) {

	var len	= patterns.length;
	for(var i = 0; i < len; i++){
		if(patterns[i].length > 1){
			return false;
		}
	}

	return true;

};


///{} 差分に応じてレイヤーカンプ生成
function createCompOnVariation(layerComps, targetLayers, variationList, eventHandler) {

	var EmptyExcepted	= _config.data.EmptyExcepted;
	var SameExcepted	= _config.data.SameExcepted;
	var Delimiter		= _config.data.Delimiter;
	var patternSingle	= isSingleChars(variationList);
//DebugUtil.add("\n\t" + variationList+ " == patternSingle: " +patternSingle+"");	//※【未完】
	var currentVariation;
	var prevVariations	= [];
	var len2;
	var equal;
	var name;
	var len	= variationList.length;
	for(var i = 0; i < len; i++){
		if(!_config.isProgressing){
			throw new ConfigDialog.CancelProgressError();
		}
		//--> 差分に応じたレイヤー表示切り替え
		currentVariation	= getVisibleOnVariation(targetLayers, variationList[i], patternSingle);
		//--? どの差分レイヤーも表示していない状態か
		if(EmptyExcepted && !Number(currentVariation)){
			continue;
		}
		//--? 表示状態の重複チェック
		if(SameExcepted){
			equal	= false;
			len2	= prevVariations.length;
			for(j = 0; j < len2; j++){
				if(currentVariation == prevVariations[j]){
					equal	= true;
					break;
				}
			}
			if(equal){
				continue;
			}
			prevVariations.push(currentVariation);
		}
		//--> 表示情報を持ったレイヤーカンプを生成
		changeVisibleOnVariation(targetLayers, currentVariation);
		name	= VARIATION_PREFIX + variationList[i].replace(TEMP_DELIMITER_REG, Delimiter);
		layerComps.add(name, StringUtil.getFullDate(), false, false, true);
		eventHandler.info	= name;
		eventHandler.onProgress(75 + Math.round((i + 1) / len * 25));	//75%==getTargetLayers
	}

};


///{$} 差分に応じた全表示状態を表すフラグ文字列を返す
function getVisibleOnVariation(targetLayers, variationName, patternSingle) {
//DebugUtil.add("patternSingle\t: "+patternSingle);
	var extractVariation_reg	= _config.global.extractVariation_reg;
	var escapeRegExp			= StringUtil.escapeRegExp;

	var patterns		= variationName.split(VARIATION_PREFIX);
	var patternLength	= patterns.length;
//DebugUtil.add("\n★patterns\t[" + variationName+ "] -> [" +patterns+"]");	//※【未完】
	//{--} レイヤー毎に差分パターンとマッチするか検証して表示状態に反映
	var RigidlyInspected	= _config.data.RigidlyInspected;
	var changeMask_reg		= _config.global.changeMask_reg;
	var flags	= "";
	var visible;
	var layer;
	var names;
	var j;
	var len2;
	var len	= targetLayers.length;

	for(var i = 0; i < len; i++){
		layer	= targetLayers[i];
//		names	= layer.name.toLowerCase).replace(extractVariation_reg, "").split(PATTERN_DELIMITER);
		names	= layer.name.replace(extractVariation_reg, "").split(PATTERN_DELIMITER);
		len2	= Math.max(patternLength, names.length);
		//{--} レイヤー名に指定された条件の分だけ検証する
		for(j = 0; j < len2; j++){
			//--? 現在パターンにレイヤー名がマッチするかどうかでレイヤーの表示状態を切り換え
			visible	= isVariationMatch(names[j], patterns[j], RigidlyInspected, layer, patternSingle);
			//--? 判定の中で一度でも撥ねられたら強制的に非表示化
			if(!visible){
				break;
			}
		}
		if(changeMask_reg.test(layer.name)){
			flags	+= (visible ? TYPE_MASK_SHOW : TYPE_MASK_HIDE);
		}else{
			flags	+= (visible ? TYPE_SHOW : TYPE_HIDE);
		}

	}

	return flags;

};


///{} 差分表示状況を示すフラグ文字列から差分レイヤーの表示状態を切り替える
function changeVisibleOnVariation(targetLayers, currentVariation) {

	var setLayerMaskVisible	= LayerUtil.setLayerMaskVisible;

	var len	= targetLayers.length;
	for(var i = 0; i < len; i++){
		switch(currentVariation.charAt(i)){
			case TYPE_SHOW:
				if(!targetLayers[i].visible){
					targetLayers[i].visible	= true;
				}
				break;
			case TYPE_MASK_HIDE:
				activeDocument.activeLayer	= targetLayers[i];
				setLayerMaskVisible(false);
				break;
			case TYPE_MASK_SHOW:
				activeDocument.activeLayer	= targetLayers[i];
				setLayerMaskVisible(true);
				break;
			case TYPE_HIDE:
			default:
				if(targetLayers[i].visible){
					targetLayers[i].visible	= false;
				}
				break;
		}
	};

};


///{?} レイヤー名の差分条件を正規表現要に変換してパターンとマッチするか返す
function isVariationMatch(name, pattern, RigidlyInspected, layer, patternSingle){

	if(!pattern){
		return RigidlyInspected ? (pattern == undefined && name == "") : true;
	}else if(!name){
		return RigidlyInspected ? (name == "") : true;
	}

	var singled		= patternSingle || (/^\^?[a-zA-Z_0-9]($|\-[a-zA-Z_0-9]$)/).test(name);
//DebugUtil.add(name + "\t" + singled + "/"+patternSingle);
	var bracket_reg	= /^\[.+\]$/;
	var fix_reg		= /^\(.*\)$/;
	var variations	= name.replace(/\|$/, "").split("|");
	var len	= variations.length;
	for(var i = 0; i < len; i++){
		if(fix_reg.test(variations[i])){
			//(!) 全体が()で囲まれているものは純粋に正規表現として扱う
		}else if(singled){
			//(!) 単体文字用として扱う場合
			if(!bracket_reg.test(variations[i])){
				variations[i]	= "[" + variations[i] + "]";
			}
		}
	}

//DebugUtil.add(new RegExp("^(" + variations.join("|") + ")$"), (new RegExp("(" + variations.join("|") + ")").test(pattern)) + "\tpattern{" +pattern+ "}\tname{" +name+ "}\tvariations{" +variations+"}\tsingled:"+singled);
	try{
		return new RegExp("(" + variations.join("|") + ")").test(pattern);
	}catch(e){
		throw new Error(e.message+ "\n(" +variations.join("\|")+")" + "\n" + layer);
	}
};


